// Generated by astgen // -*- mode: C++; c-file-style: "cc-mode" -*-
case VNType::atAcosD: {
    const AstAcosD* const currp = static_cast<const AstAcosD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAcosD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAcosD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAcosD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAcosD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAcosD does not use op4p()");
    break;
}
case VNType::atAcoshD: {
    const AstAcoshD* const currp = static_cast<const AstAcoshD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAcoshD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAcoshD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAcoshD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAcoshD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAcoshD does not use op4p()");
    break;
}
case VNType::atActive: {
    const AstActive* const currp = static_cast<const AstActive*>(this);
    // Checking op1p
    if (AstSenTree* const opp = currp->sensesStorep()) {
        UASSERT_OBJ(!currp->sensesStorep()->nextp(), currp, "AstActive::sensesStorep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstActive does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstActive does not use op4p()");
    break;
}
case VNType::atAdd: {
    const AstAdd* const currp = static_cast<const AstAdd*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAdd must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAdd::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAdd must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAdd::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAdd does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAdd does not use op4p()");
    break;
}
case VNType::atAddD: {
    const AstAddD* const currp = static_cast<const AstAddD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAddD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAddD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAddD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAddD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAddD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAddD does not use op4p()");
    break;
}
case VNType::atAddrOfCFunc: {
    const AstAddrOfCFunc* const currp = static_cast<const AstAddrOfCFunc*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstAddrOfCFunc does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAddrOfCFunc does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAddrOfCFunc does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAddrOfCFunc does not use op4p()");
    break;
}
case VNType::atAlways: {
    const AstAlways* const currp = static_cast<const AstAlways*>(this);
    // Checking op1p
    if (AstSenTree* const opp = currp->sensesp()) {
        UASSERT_OBJ(!currp->sensesp()->nextp(), currp, "AstAlways::sensesp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAlways does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAlways does not use op4p()");
    break;
}
case VNType::atAlwaysObserved: {
    const AstAlwaysObserved* const currp = static_cast<const AstAlwaysObserved*>(this);
    // Checking op1p
    if (AstSenTree* const opp = currp->sensesp()) {
        UASSERT_OBJ(!currp->sensesp()->nextp(), currp, "AstAlwaysObserved::sensesp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAlwaysObserved does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAlwaysObserved does not use op4p()");
    break;
}
case VNType::atAlwaysPost: {
    const AstAlwaysPost* const currp = static_cast<const AstAlwaysPost*>(this);
    // Checking op1p
    if (AstSenTree* const opp = currp->sensesp()) {
        UASSERT_OBJ(!currp->sensesp()->nextp(), currp, "AstAlwaysPost::sensesp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAlwaysPost does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAlwaysPost does not use op4p()");
    break;
}
case VNType::atAlwaysPostponed: {
    const AstAlwaysPostponed* const currp = static_cast<const AstAlwaysPostponed*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstAlwaysPostponed does not use op1p()");
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAlwaysPostponed does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAlwaysPostponed does not use op4p()");
    break;
}
case VNType::atAlwaysPublic: {
    const AstAlwaysPublic* const currp = static_cast<const AstAlwaysPublic*>(this);
    // Checking op1p
    if (const AstSenTree* const headp = currp->sensesp()) {
        const AstNode* backp = currp;
        const AstSenTree* tailp = headp;
        const AstSenTree* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), SenTree);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAlwaysPublic does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAlwaysPublic does not use op4p()");
    break;
}
case VNType::atAlwaysReactive: {
    const AstAlwaysReactive* const currp = static_cast<const AstAlwaysReactive*>(this);
    // Checking op1p
    if (AstSenTree* const opp = currp->sensesp()) {
        UASSERT_OBJ(!currp->sensesp()->nextp(), currp, "AstAlwaysReactive::sensesp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAlwaysReactive does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAlwaysReactive does not use op4p()");
    break;
}
case VNType::atAnd: {
    const AstAnd* const currp = static_cast<const AstAnd*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAnd must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAnd::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAnd must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAnd::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAnd does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAnd does not use op4p()");
    break;
}
case VNType::atArg: {
    const AstArg* const currp = static_cast<const AstArg*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->exprp()) {
        UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstArg::exprp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstArg does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstArg does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstArg does not use op4p()");
    break;
}
case VNType::atArraySel: {
    const AstArraySel* const currp = static_cast<const AstArraySel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstArraySel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstArraySel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->bitp(), currp, "AstArraySel must have non nullptr bitp()");
    UASSERT_OBJ(!currp->bitp()->nextp(), currp, "AstArraySel::bitp() cannot have a non nullptr nextp()");
    currp->bitp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstArraySel does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstArraySel does not use op4p()");
    break;
}
case VNType::atAsinD: {
    const AstAsinD* const currp = static_cast<const AstAsinD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAsinD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAsinD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAsinD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAsinD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAsinD does not use op4p()");
    break;
}
case VNType::atAsinhD: {
    const AstAsinhD* const currp = static_cast<const AstAsinhD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAsinhD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAsinhD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAsinhD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAsinhD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAsinhD does not use op4p()");
    break;
}
case VNType::atAssert: {
    const AstAssert* const currp = static_cast<const AstAssert*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->propp(), currp, "AstAssert must have non nullptr propp()");
    UASSERT_OBJ(!currp->propp()->nextp(), currp, "AstAssert::propp() cannot have a non nullptr nextp()");
    currp->propp()->checkTreeIter(currp);
    // Checking op2p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstAssert::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (const AstNode* const headp = currp->failsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (const AstNode* const headp = currp->passsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atAssertIntrinsic: {
    const AstAssertIntrinsic* const currp = static_cast<const AstAssertIntrinsic*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->propp(), currp, "AstAssertIntrinsic must have non nullptr propp()");
    UASSERT_OBJ(!currp->propp()->nextp(), currp, "AstAssertIntrinsic::propp() cannot have a non nullptr nextp()");
    currp->propp()->checkTreeIter(currp);
    // Checking op2p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstAssertIntrinsic::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (const AstNode* const headp = currp->failsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (const AstNode* const headp = currp->passsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atAssign: {
    const AstAssign* const currp = static_cast<const AstAssign*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssign must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssign::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssign must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssign::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssign::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssign does not use op4p()");
    break;
}
case VNType::atAssignAlias: {
    const AstAssignAlias* const currp = static_cast<const AstAssignAlias*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssignAlias must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssignAlias::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssignAlias must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssignAlias::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssignAlias::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssignAlias does not use op4p()");
    break;
}
case VNType::atAssignDly: {
    const AstAssignDly* const currp = static_cast<const AstAssignDly*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssignDly must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssignDly::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssignDly must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssignDly::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssignDly::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssignDly does not use op4p()");
    break;
}
case VNType::atAssignForce: {
    const AstAssignForce* const currp = static_cast<const AstAssignForce*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssignForce must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssignForce::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssignForce must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssignForce::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssignForce::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssignForce does not use op4p()");
    break;
}
case VNType::atAssignPost: {
    const AstAssignPost* const currp = static_cast<const AstAssignPost*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssignPost must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssignPost::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssignPost must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssignPost::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssignPost::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssignPost does not use op4p()");
    break;
}
case VNType::atAssignPre: {
    const AstAssignPre* const currp = static_cast<const AstAssignPre*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssignPre must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssignPre::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssignPre must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssignPre::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssignPre::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssignPre does not use op4p()");
    break;
}
case VNType::atAssignVarScope: {
    const AstAssignVarScope* const currp = static_cast<const AstAssignVarScope*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssignVarScope must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssignVarScope::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssignVarScope must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssignVarScope::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssignVarScope::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssignVarScope does not use op4p()");
    break;
}
case VNType::atAssignW: {
    const AstAssignW* const currp = static_cast<const AstAssignW*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAssignW must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAssignW::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAssignW must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAssignW::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->timingControlp()) {
        UASSERT_OBJ(!currp->timingControlp()->nextp(), currp, "AstAssignW::timingControlp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstStrengthSpec* const opp = currp->strengthSpecp()) {
        UASSERT_OBJ(!currp->strengthSpecp()->nextp(), currp, "AstAssignW::strengthSpecp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atAssocArrayDType: {
    const AstAssocArrayDType* const currp = static_cast<const AstAssocArrayDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstAssocArrayDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeDType* const opp = currp->keyChildDTypep()) {
        UASSERT_OBJ(!currp->keyChildDTypep()->nextp(), currp, "AstAssocArrayDType::keyChildDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAssocArrayDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssocArrayDType does not use op4p()");
    break;
}
case VNType::atAssocSel: {
    const AstAssocSel* const currp = static_cast<const AstAssocSel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstAssocSel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstAssocSel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->bitp(), currp, "AstAssocSel must have non nullptr bitp()");
    UASSERT_OBJ(!currp->bitp()->nextp(), currp, "AstAssocSel::bitp() cannot have a non nullptr nextp()");
    currp->bitp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAssocSel does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAssocSel does not use op4p()");
    break;
}
case VNType::atAtan2D: {
    const AstAtan2D* const currp = static_cast<const AstAtan2D*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAtan2D must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAtan2D::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstAtan2D must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstAtan2D::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAtan2D does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAtan2D does not use op4p()");
    break;
}
case VNType::atAtanD: {
    const AstAtanD* const currp = static_cast<const AstAtanD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAtanD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAtanD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAtanD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAtanD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAtanD does not use op4p()");
    break;
}
case VNType::atAtanhD: {
    const AstAtanhD* const currp = static_cast<const AstAtanhD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAtanhD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAtanhD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAtanhD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAtanhD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAtanhD does not use op4p()");
    break;
}
case VNType::atAtoN: {
    const AstAtoN* const currp = static_cast<const AstAtoN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstAtoN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstAtoN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstAtoN does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAtoN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAtoN does not use op4p()");
    break;
}
case VNType::atAttrOf: {
    const AstAttrOf* const currp = static_cast<const AstAttrOf*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->fromp()) {
        UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstAttrOf::fromp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeExpr* const opp = currp->dimp()) {
        UASSERT_OBJ(!currp->dimp()->nextp(), currp, "AstAttrOf::dimp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstAttrOf does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstAttrOf does not use op4p()");
    break;
}
case VNType::atBasicDType: {
    const AstBasicDType* const currp = static_cast<const AstBasicDType*>(this);
    // Checking op1p
    if (AstRange* const opp = currp->rangep()) {
        UASSERT_OBJ(!currp->rangep()->nextp(), currp, "AstBasicDType::rangep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstBasicDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBasicDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBasicDType does not use op4p()");
    break;
}
case VNType::atBegin: {
    const AstBegin* const currp = static_cast<const AstBegin*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (AstNode* const opp = currp->genforp()) {
        UASSERT_OBJ(!currp->genforp()->nextp(), currp, "AstBegin::genforp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBegin does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBegin does not use op4p()");
    break;
}
case VNType::atBind: {
    const AstBind* const currp = static_cast<const AstBind*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->cellsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstBind does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBind does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBind does not use op4p()");
    break;
}
case VNType::atBitsToRealD: {
    const AstBitsToRealD* const currp = static_cast<const AstBitsToRealD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstBitsToRealD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstBitsToRealD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstBitsToRealD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBitsToRealD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBitsToRealD does not use op4p()");
    break;
}
case VNType::atBracketArrayDType: {
    const AstBracketArrayDType* const currp = static_cast<const AstBracketArrayDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstBracketArrayDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(currp->elementsp(), currp, "AstBracketArrayDType must have non nullptr elementsp()");
    UASSERT_OBJ(!currp->elementsp()->nextp(), currp, "AstBracketArrayDType::elementsp() cannot have a non nullptr nextp()");
    currp->elementsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBracketArrayDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBracketArrayDType does not use op4p()");
    break;
}
case VNType::atBracketRange: {
    const AstBracketRange* const currp = static_cast<const AstBracketRange*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->elementsp(), currp, "AstBracketRange must have non nullptr elementsp()");
    UASSERT_OBJ(!currp->elementsp()->nextp(), currp, "AstBracketRange::elementsp() cannot have a non nullptr nextp()");
    currp->elementsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstBracketRange does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBracketRange does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBracketRange does not use op4p()");
    break;
}
case VNType::atBreak: {
    const AstBreak* const currp = static_cast<const AstBreak*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstBreak does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstBreak does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBreak does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBreak does not use op4p()");
    break;
}
case VNType::atBufIf1: {
    const AstBufIf1* const currp = static_cast<const AstBufIf1*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstBufIf1 must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstBufIf1::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstBufIf1 must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstBufIf1::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstBufIf1 does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstBufIf1 does not use op4p()");
    break;
}
case VNType::atCAwait: {
    const AstCAwait* const currp = static_cast<const AstCAwait*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstCAwait must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstCAwait::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCAwait does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCAwait does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCAwait does not use op4p()");
    break;
}
case VNType::atCCall: {
    const AstCCall* const currp = static_cast<const AstCCall*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstCCall does not use op1p()");
    // Checking op2p
    if (const AstNodeExpr* const headp = currp->argsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCCall does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCCall does not use op4p()");
    break;
}
case VNType::atCCast: {
    const AstCCast* const currp = static_cast<const AstCCast*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCCast must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCCast::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCCast does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCCast does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCCast does not use op4p()");
    break;
}
case VNType::atCExpr: {
    const AstCExpr* const currp = static_cast<const AstCExpr*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCExpr does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCExpr does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCExpr does not use op4p()");
    break;
}
case VNType::atCFile: {
    const AstCFile* const currp = static_cast<const AstCFile*>(this);
    // Checking op1p
    if (AstTextBlock* const opp = currp->tblockp()) {
        UASSERT_OBJ(!currp->tblockp()->nextp(), currp, "AstCFile::tblockp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCFile does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCFile does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCFile does not use op4p()");
    break;
}
case VNType::atCFunc: {
    const AstCFunc* const currp = static_cast<const AstCFunc*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->argsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->initsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (const AstNode* const headp = currp->finalsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atCLog2: {
    const AstCLog2* const currp = static_cast<const AstCLog2*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCLog2 must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCLog2::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCLog2 does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCLog2 does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCLog2 does not use op4p()");
    break;
}
case VNType::atCMethodCall: {
    const AstCMethodCall* const currp = static_cast<const AstCMethodCall*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstCMethodCall must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstCMethodCall::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNodeExpr* const headp = currp->argsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCMethodCall does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCMethodCall does not use op4p()");
    break;
}
case VNType::atCMethodHard: {
    const AstCMethodHard* const currp = static_cast<const AstCMethodHard*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstCMethodHard must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstCMethodHard::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNodeExpr* const headp = currp->pinsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCMethodHard does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCMethodHard does not use op4p()");
    break;
}
case VNType::atCNew: {
    const AstCNew* const currp = static_cast<const AstCNew*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstCNew does not use op1p()");
    // Checking op2p
    if (const AstNodeExpr* const headp = currp->argsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCNew does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCNew does not use op4p()");
    break;
}
case VNType::atCReset: {
    const AstCReset* const currp = static_cast<const AstCReset*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->varrefp(), currp, "AstCReset must have non nullptr varrefp()");
    UASSERT_OBJ(!currp->varrefp()->nextp(), currp, "AstCReset::varrefp() cannot have a non nullptr nextp()");
    currp->varrefp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCReset does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCReset does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCReset does not use op4p()");
    break;
}
case VNType::atCReturn: {
    const AstCReturn* const currp = static_cast<const AstCReturn*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCReturn must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCReturn::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCReturn does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCReturn does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCReturn does not use op4p()");
    break;
}
case VNType::atCStmt: {
    const AstCStmt* const currp = static_cast<const AstCStmt*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCStmt does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCStmt does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCStmt does not use op4p()");
    break;
}
case VNType::atCUse: {
    const AstCUse* const currp = static_cast<const AstCUse*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstCUse does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCUse does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCUse does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCUse does not use op4p()");
    break;
}
case VNType::atCase: {
    const AstCase* const currp = static_cast<const AstCase*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstCase must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstCase::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstCaseItem* const headp = currp->itemsp()) {
        const AstNode* backp = currp;
        const AstCaseItem* tailp = headp;
        const AstCaseItem* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), CaseItem);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstNode* const headp = currp->notParallelp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCase does not use op4p()");
    break;
}
case VNType::atCaseItem: {
    const AstCaseItem* const currp = static_cast<const AstCaseItem*>(this);
    // Checking op1p
    if (const AstNodeExpr* const headp = currp->condsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCaseItem does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCaseItem does not use op4p()");
    break;
}
case VNType::atCast: {
    const AstCast* const currp = static_cast<const AstCast*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstCast must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstCast::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstCast::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCast does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCast does not use op4p()");
    break;
}
case VNType::atCastDynamic: {
    const AstCastDynamic* const currp = static_cast<const AstCastDynamic*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstCastDynamic must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstCastDynamic::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->top(), currp, "AstCastDynamic must have non nullptr top()");
    UASSERT_OBJ(!currp->top()->nextp(), currp, "AstCastDynamic::top() cannot have a non nullptr nextp()");
    currp->top()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCastDynamic does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCastDynamic does not use op4p()");
    break;
}
case VNType::atCastParse: {
    const AstCastParse* const currp = static_cast<const AstCastParse*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCastParse must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCastParse::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->dtp(), currp, "AstCastParse must have non nullptr dtp()");
    UASSERT_OBJ(!currp->dtp()->nextp(), currp, "AstCastParse::dtp() cannot have a non nullptr nextp()");
    currp->dtp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCastParse does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCastParse does not use op4p()");
    break;
}
case VNType::atCastSize: {
    const AstCastSize* const currp = static_cast<const AstCastSize*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCastSize must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCastSize::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstCastSize must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstCastSize::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCastSize does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCastSize does not use op4p()");
    break;
}
case VNType::atCastWrap: {
    const AstCastWrap* const currp = static_cast<const AstCastWrap*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCastWrap must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCastWrap::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCastWrap does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCastWrap does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCastWrap does not use op4p()");
    break;
}
case VNType::atCeilD: {
    const AstCeilD* const currp = static_cast<const AstCeilD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCeilD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCeilD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCeilD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCeilD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCeilD does not use op4p()");
    break;
}
case VNType::atCell: {
    const AstCell* const currp = static_cast<const AstCell*>(this);
    // Checking op1p
    if (const AstPin* const headp = currp->pinsp()) {
        const AstNode* backp = currp;
        const AstPin* tailp = headp;
        const AstPin* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Pin);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstPin* const headp = currp->paramsp()) {
        const AstNode* backp = currp;
        const AstPin* tailp = headp;
        const AstPin* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Pin);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (AstRange* const opp = currp->rangep()) {
        UASSERT_OBJ(!currp->rangep()->nextp(), currp, "AstCell::rangep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (const AstIntfRef* const headp = currp->intfRefsp()) {
        const AstNode* backp = currp;
        const AstIntfRef* tailp = headp;
        const AstIntfRef* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), IntfRef);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atCellArrayRef: {
    const AstCellArrayRef* const currp = static_cast<const AstCellArrayRef*>(this);
    // Checking op1p
    if (const AstNodeExpr* const headp = currp->selp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCellArrayRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCellArrayRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCellArrayRef does not use op4p()");
    break;
}
case VNType::atCellInline: {
    const AstCellInline* const currp = static_cast<const AstCellInline*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstCellInline does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCellInline does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCellInline does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCellInline does not use op4p()");
    break;
}
case VNType::atCellRef: {
    const AstCellRef* const currp = static_cast<const AstCellRef*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->cellp(), currp, "AstCellRef must have non nullptr cellp()");
    UASSERT_OBJ(!currp->cellp()->nextp(), currp, "AstCellRef::cellp() cannot have a non nullptr nextp()");
    currp->cellp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->exprp(), currp, "AstCellRef must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstCellRef::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCellRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCellRef does not use op4p()");
    break;
}
case VNType::atClass: {
    const AstClass* const currp = static_cast<const AstClass*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->inlinesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstActive* const headp = currp->activesp()) {
        const AstNode* backp = currp;
        const AstActive* tailp = headp;
        const AstActive* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Active);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (const AstClassExtends* const headp = currp->extendsp()) {
        const AstNode* backp = currp;
        const AstClassExtends* tailp = headp;
        const AstClassExtends* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), ClassExtends);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atClassExtends: {
    const AstClassExtends* const currp = static_cast<const AstClassExtends*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstClassExtends::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNode* const opp = currp->classOrPkgsp()) {
        UASSERT_OBJ(!currp->classOrPkgsp()->nextp(), currp, "AstClassExtends::classOrPkgsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstClassExtends does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstClassExtends does not use op4p()");
    break;
}
case VNType::atClassOrPackageRef: {
    const AstClassOrPackageRef* const currp = static_cast<const AstClassOrPackageRef*>(this);
    // Checking op1p
    if (const AstPin* const headp = currp->paramsp()) {
        const AstNode* backp = currp;
        const AstPin* tailp = headp;
        const AstPin* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Pin);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstClassOrPackageRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstClassOrPackageRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstClassOrPackageRef does not use op4p()");
    break;
}
case VNType::atClassPackage: {
    const AstClassPackage* const currp = static_cast<const AstClassPackage*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->inlinesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstActive* const headp = currp->activesp()) {
        const AstNode* backp = currp;
        const AstActive* tailp = headp;
        const AstActive* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Active);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstClassPackage does not use op4p()");
    break;
}
case VNType::atClassRefDType: {
    const AstClassRefDType* const currp = static_cast<const AstClassRefDType*>(this);
    // Checking op1p
    if (const AstPin* const headp = currp->paramsp()) {
        const AstNode* backp = currp;
        const AstPin* tailp = headp;
        const AstPin* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Pin);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstClassRefDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstClassRefDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstClassRefDType does not use op4p()");
    break;
}
case VNType::atClocking: {
    const AstClocking* const currp = static_cast<const AstClocking*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->sensesp(), currp, "AstClocking must have non nullptr sensesp()");
    UASSERT_OBJ(!currp->sensesp()->nextp(), currp, "AstClocking::sensesp() cannot have a non nullptr nextp()");
    currp->sensesp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstClockingItem* const headp = currp->itemsp()) {
        const AstNode* backp = currp;
        const AstClockingItem* tailp = headp;
        const AstClockingItem* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), ClockingItem);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstVar* const headp = currp->varsp()) {
        const AstNode* backp = currp;
        const AstVar* tailp = headp;
        const AstVar* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Var);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstVar* const opp = currp->eventp()) {
        UASSERT_OBJ(!currp->eventp()->nextp(), currp, "AstClocking::eventp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atClockingItem: {
    const AstClockingItem* const currp = static_cast<const AstClockingItem*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->skewp()) {
        UASSERT_OBJ(!currp->skewp()->nextp(), currp, "AstClockingItem::skewp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeExpr* const opp = currp->exprp()) {
        UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstClockingItem::exprp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (AstAssign* const opp = currp->assignp()) {
        UASSERT_OBJ(!currp->assignp()->nextp(), currp, "AstClockingItem::assignp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstVar* const opp = currp->varp()) {
        UASSERT_OBJ(!currp->varp()->nextp(), currp, "AstClockingItem::varp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atComment: {
    const AstComment* const currp = static_cast<const AstComment*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstComment does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstComment does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstComment does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstComment does not use op4p()");
    break;
}
case VNType::atCompareNN: {
    const AstCompareNN* const currp = static_cast<const AstCompareNN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCompareNN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCompareNN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstCompareNN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstCompareNN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCompareNN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCompareNN does not use op4p()");
    break;
}
case VNType::atConcat: {
    const AstConcat* const currp = static_cast<const AstConcat*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstConcat must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstConcat::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstConcat must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstConcat::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConcat does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConcat does not use op4p()");
    break;
}
case VNType::atConcatN: {
    const AstConcatN* const currp = static_cast<const AstConcatN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstConcatN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstConcatN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstConcatN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstConcatN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConcatN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConcatN does not use op4p()");
    break;
}
case VNType::atCond: {
    const AstCond* const currp = static_cast<const AstCond*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->condp(), currp, "AstCond must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstCond::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->thenp(), currp, "AstCond must have non nullptr thenp()");
    UASSERT_OBJ(!currp->thenp()->nextp(), currp, "AstCond::thenp() cannot have a non nullptr nextp()");
    currp->thenp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->elsep(), currp, "AstCond must have non nullptr elsep()");
    UASSERT_OBJ(!currp->elsep()->nextp(), currp, "AstCond::elsep() cannot have a non nullptr nextp()");
    currp->elsep()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCond does not use op4p()");
    break;
}
case VNType::atCondBound: {
    const AstCondBound* const currp = static_cast<const AstCondBound*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->condp(), currp, "AstCondBound must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstCondBound::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->thenp(), currp, "AstCondBound must have non nullptr thenp()");
    UASSERT_OBJ(!currp->thenp()->nextp(), currp, "AstCondBound::thenp() cannot have a non nullptr nextp()");
    currp->thenp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->elsep(), currp, "AstCondBound must have non nullptr elsep()");
    UASSERT_OBJ(!currp->elsep()->nextp(), currp, "AstCondBound::elsep() cannot have a non nullptr nextp()");
    currp->elsep()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCondBound does not use op4p()");
    break;
}
case VNType::atConsAssoc: {
    const AstConsAssoc* const currp = static_cast<const AstConsAssoc*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->defaultp()) {
        UASSERT_OBJ(!currp->defaultp()->nextp(), currp, "AstConsAssoc::defaultp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstConsAssoc does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConsAssoc does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConsAssoc does not use op4p()");
    break;
}
case VNType::atConsDynArray: {
    const AstConsDynArray* const currp = static_cast<const AstConsDynArray*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->lhsp()) {
        UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstConsDynArray::lhsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNode* const opp = currp->rhsp()) {
        UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstConsDynArray::rhsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConsDynArray does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConsDynArray does not use op4p()");
    break;
}
case VNType::atConsPackMember: {
    const AstConsPackMember* const currp = static_cast<const AstConsPackMember*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstConsPackMember does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstConsPackMember must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstConsPackMember::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConsPackMember does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConsPackMember does not use op4p()");
    break;
}
case VNType::atConsPackUOrStruct: {
    const AstConsPackUOrStruct* const currp = static_cast<const AstConsPackUOrStruct*>(this);
    // Checking op1p
    if (const AstConsPackMember* const headp = currp->membersp()) {
        const AstNode* backp = currp;
        const AstConsPackMember* tailp = headp;
        const AstConsPackMember* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), ConsPackMember);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstConsPackUOrStruct does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConsPackUOrStruct does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConsPackUOrStruct does not use op4p()");
    break;
}
case VNType::atConsQueue: {
    const AstConsQueue* const currp = static_cast<const AstConsQueue*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->lhsp()) {
        UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstConsQueue::lhsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNode* const opp = currp->rhsp()) {
        UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstConsQueue::rhsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConsQueue does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConsQueue does not use op4p()");
    break;
}
case VNType::atConsWildcard: {
    const AstConsWildcard* const currp = static_cast<const AstConsWildcard*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->defaultp()) {
        UASSERT_OBJ(!currp->defaultp()->nextp(), currp, "AstConsWildcard::defaultp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstConsWildcard does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConsWildcard does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConsWildcard does not use op4p()");
    break;
}
case VNType::atConst: {
    const AstConst* const currp = static_cast<const AstConst*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstConst does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstConst does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConst does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConst does not use op4p()");
    break;
}
case VNType::atConstDType: {
    const AstConstDType* const currp = static_cast<const AstConstDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstConstDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstConstDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConstDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConstDType does not use op4p()");
    break;
}
case VNType::atConstPool: {
    const AstConstPool* const currp = static_cast<const AstConstPool*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->modulep(), currp, "AstConstPool must have non nullptr modulep()");
    UASSERT_OBJ(!currp->modulep()->nextp(), currp, "AstConstPool::modulep() cannot have a non nullptr nextp()");
    currp->modulep()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstConstPool does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstConstPool does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstConstPool does not use op4p()");
    break;
}
case VNType::atContinue: {
    const AstContinue* const currp = static_cast<const AstContinue*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstContinue does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstContinue does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstContinue does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstContinue does not use op4p()");
    break;
}
case VNType::atCosD: {
    const AstCosD* const currp = static_cast<const AstCosD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCosD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCosD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCosD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCosD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCosD does not use op4p()");
    break;
}
case VNType::atCoshD: {
    const AstCoshD* const currp = static_cast<const AstCoshD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCoshD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCoshD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCoshD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCoshD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCoshD does not use op4p()");
    break;
}
case VNType::atCountBits: {
    const AstCountBits* const currp = static_cast<const AstCountBits*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCountBits must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCountBits::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstCountBits must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstCountBits::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstCountBits must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstCountBits::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(currp->fhsp(), currp, "AstCountBits must have non nullptr fhsp()");
    UASSERT_OBJ(!currp->fhsp()->nextp(), currp, "AstCountBits::fhsp() cannot have a non nullptr nextp()");
    currp->fhsp()->checkTreeIter(currp);
    break;
}
case VNType::atCountOnes: {
    const AstCountOnes* const currp = static_cast<const AstCountOnes*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCountOnes must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCountOnes::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCountOnes does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCountOnes does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCountOnes does not use op4p()");
    break;
}
case VNType::atCover: {
    const AstCover* const currp = static_cast<const AstCover*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->propp(), currp, "AstCover must have non nullptr propp()");
    UASSERT_OBJ(!currp->propp()->nextp(), currp, "AstCover::propp() cannot have a non nullptr nextp()");
    currp->propp()->checkTreeIter(currp);
    // Checking op2p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstCover::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (const AstNode* const headp = currp->coverincsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (const AstNode* const headp = currp->passsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atCoverDecl: {
    const AstCoverDecl* const currp = static_cast<const AstCoverDecl*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstCoverDecl does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCoverDecl does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCoverDecl does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCoverDecl does not use op4p()");
    break;
}
case VNType::atCoverInc: {
    const AstCoverInc* const currp = static_cast<const AstCoverInc*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstCoverInc does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCoverInc does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCoverInc does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCoverInc does not use op4p()");
    break;
}
case VNType::atCoverToggle: {
    const AstCoverToggle* const currp = static_cast<const AstCoverToggle*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->incp(), currp, "AstCoverToggle must have non nullptr incp()");
    UASSERT_OBJ(!currp->incp()->nextp(), currp, "AstCoverToggle::incp() cannot have a non nullptr nextp()");
    currp->incp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->origp(), currp, "AstCoverToggle must have non nullptr origp()");
    UASSERT_OBJ(!currp->origp()->nextp(), currp, "AstCoverToggle::origp() cannot have a non nullptr nextp()");
    currp->origp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->changep(), currp, "AstCoverToggle must have non nullptr changep()");
    UASSERT_OBJ(!currp->changep()->nextp(), currp, "AstCoverToggle::changep() cannot have a non nullptr nextp()");
    currp->changep()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCoverToggle does not use op4p()");
    break;
}
case VNType::atCvtPackString: {
    const AstCvtPackString* const currp = static_cast<const AstCvtPackString*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstCvtPackString must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstCvtPackString::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstCvtPackString does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstCvtPackString does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstCvtPackString does not use op4p()");
    break;
}
case VNType::atDefImplicitDType: {
    const AstDefImplicitDType* const currp = static_cast<const AstDefImplicitDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstDefImplicitDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstDefImplicitDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDefImplicitDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDefImplicitDType does not use op4p()");
    break;
}
case VNType::atDefParam: {
    const AstDefParam* const currp = static_cast<const AstDefParam*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDefParam must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDefParam::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstDefParam does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDefParam does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDefParam does not use op4p()");
    break;
}
case VNType::atDelay: {
    const AstDelay* const currp = static_cast<const AstDelay*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDelay must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDelay::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDelay does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDelay does not use op4p()");
    break;
}
case VNType::atDisable: {
    const AstDisable* const currp = static_cast<const AstDisable*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstDisable does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstDisable does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDisable does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDisable does not use op4p()");
    break;
}
case VNType::atDisableFork: {
    const AstDisableFork* const currp = static_cast<const AstDisableFork*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstDisableFork does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstDisableFork does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDisableFork does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDisableFork does not use op4p()");
    break;
}
case VNType::atDisplay: {
    const AstDisplay* const currp = static_cast<const AstDisplay*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fmtp(), currp, "AstDisplay must have non nullptr fmtp()");
    UASSERT_OBJ(!currp->fmtp()->nextp(), currp, "AstDisplay::fmtp() cannot have a non nullptr nextp()");
    currp->fmtp()->checkTreeIter(currp);
    // Checking op2p
    if (AstNodeExpr* const opp = currp->filep()) {
        UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstDisplay::filep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDisplay does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDisplay does not use op4p()");
    break;
}
case VNType::atDistChiSquare: {
    const AstDistChiSquare* const currp = static_cast<const AstDistChiSquare*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDistChiSquare must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDistChiSquare::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDistChiSquare must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDistChiSquare::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDistChiSquare does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDistChiSquare does not use op4p()");
    break;
}
case VNType::atDistErlang: {
    const AstDistErlang* const currp = static_cast<const AstDistErlang*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDistErlang must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDistErlang::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDistErlang must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDistErlang::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstDistErlang must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstDistErlang::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDistErlang does not use op4p()");
    break;
}
case VNType::atDistExponential: {
    const AstDistExponential* const currp = static_cast<const AstDistExponential*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDistExponential must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDistExponential::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDistExponential must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDistExponential::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDistExponential does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDistExponential does not use op4p()");
    break;
}
case VNType::atDistNormal: {
    const AstDistNormal* const currp = static_cast<const AstDistNormal*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDistNormal must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDistNormal::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDistNormal must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDistNormal::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstDistNormal must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstDistNormal::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDistNormal does not use op4p()");
    break;
}
case VNType::atDistPoisson: {
    const AstDistPoisson* const currp = static_cast<const AstDistPoisson*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDistPoisson must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDistPoisson::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDistPoisson must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDistPoisson::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDistPoisson does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDistPoisson does not use op4p()");
    break;
}
case VNType::atDistT: {
    const AstDistT* const currp = static_cast<const AstDistT*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDistT must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDistT::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDistT must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDistT::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDistT does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDistT does not use op4p()");
    break;
}
case VNType::atDistUniform: {
    const AstDistUniform* const currp = static_cast<const AstDistUniform*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDistUniform must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDistUniform::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDistUniform must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDistUniform::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstDistUniform must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstDistUniform::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDistUniform does not use op4p()");
    break;
}
case VNType::atDiv: {
    const AstDiv* const currp = static_cast<const AstDiv*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDiv must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDiv::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDiv must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDiv::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDiv does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDiv does not use op4p()");
    break;
}
case VNType::atDivD: {
    const AstDivD* const currp = static_cast<const AstDivD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDivD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDivD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDivD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDivD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDivD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDivD does not use op4p()");
    break;
}
case VNType::atDivS: {
    const AstDivS* const currp = static_cast<const AstDivS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDivS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDivS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDivS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDivS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDivS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDivS does not use op4p()");
    break;
}
case VNType::atDoWhile: {
    const AstDoWhile* const currp = static_cast<const AstDoWhile*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->condp(), currp, "AstDoWhile must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstDoWhile::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDoWhile does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDoWhile does not use op4p()");
    break;
}
case VNType::atDot: {
    const AstDot* const currp = static_cast<const AstDot*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstDot must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstDot::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstDot must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstDot::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDot does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDot does not use op4p()");
    break;
}
case VNType::atDpiExport: {
    const AstDpiExport* const currp = static_cast<const AstDpiExport*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstDpiExport does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstDpiExport does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDpiExport does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDpiExport does not use op4p()");
    break;
}
case VNType::atDumpCtl: {
    const AstDumpCtl* const currp = static_cast<const AstDumpCtl*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->exprp()) {
        UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstDumpCtl::exprp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstDumpCtl does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDumpCtl does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDumpCtl does not use op4p()");
    break;
}
case VNType::atDynArrayDType: {
    const AstDynArrayDType* const currp = static_cast<const AstDynArrayDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstDynArrayDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstDynArrayDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstDynArrayDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstDynArrayDType does not use op4p()");
    break;
}
case VNType::atElabDisplay: {
    const AstElabDisplay* const currp = static_cast<const AstElabDisplay*>(this);
    // Checking op1p
    if (const AstSFormatF* const headp = currp->fmtp()) {
        const AstNode* backp = currp;
        const AstSFormatF* tailp = headp;
        const AstSFormatF* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), SFormatF);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstElabDisplay does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstElabDisplay does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstElabDisplay does not use op4p()");
    break;
}
case VNType::atEmpty: {
    const AstEmpty* const currp = static_cast<const AstEmpty*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstEmpty does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstEmpty does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEmpty does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEmpty does not use op4p()");
    break;
}
case VNType::atEmptyQueue: {
    const AstEmptyQueue* const currp = static_cast<const AstEmptyQueue*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstEmptyQueue does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstEmptyQueue does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEmptyQueue does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEmptyQueue does not use op4p()");
    break;
}
case VNType::atEmptyQueueDType: {
    const AstEmptyQueueDType* const currp = static_cast<const AstEmptyQueueDType*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstEmptyQueueDType does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstEmptyQueueDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEmptyQueueDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEmptyQueueDType does not use op4p()");
    break;
}
case VNType::atEnumDType: {
    const AstEnumDType* const currp = static_cast<const AstEnumDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstEnumDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstEnumItem* const headp = currp->itemsp()) {
        const AstNode* backp = currp;
        const AstEnumItem* tailp = headp;
        const AstEnumItem* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), EnumItem);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEnumDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEnumDType does not use op4p()");
    break;
}
case VNType::atEnumItem: {
    const AstEnumItem* const currp = static_cast<const AstEnumItem*>(this);
    // Checking op1p
    if (AstRange* const opp = currp->rangep()) {
        UASSERT_OBJ(!currp->rangep()->nextp(), currp, "AstEnumItem::rangep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeExpr* const opp = currp->valuep()) {
        UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstEnumItem::valuep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEnumItem does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEnumItem does not use op4p()");
    break;
}
case VNType::atEnumItemRef: {
    const AstEnumItemRef* const currp = static_cast<const AstEnumItemRef*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstEnumItemRef does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstEnumItemRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEnumItemRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEnumItemRef does not use op4p()");
    break;
}
case VNType::atEq: {
    const AstEq* const currp = static_cast<const AstEq*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstEq must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstEq::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstEq must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstEq::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEq does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEq does not use op4p()");
    break;
}
case VNType::atEqCase: {
    const AstEqCase* const currp = static_cast<const AstEqCase*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstEqCase must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstEqCase::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstEqCase must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstEqCase::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEqCase does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEqCase does not use op4p()");
    break;
}
case VNType::atEqD: {
    const AstEqD* const currp = static_cast<const AstEqD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstEqD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstEqD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstEqD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstEqD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEqD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEqD does not use op4p()");
    break;
}
case VNType::atEqN: {
    const AstEqN* const currp = static_cast<const AstEqN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstEqN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstEqN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstEqN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstEqN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEqN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEqN does not use op4p()");
    break;
}
case VNType::atEqT: {
    const AstEqT* const currp = static_cast<const AstEqT*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstEqT must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstEqT::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstEqT must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstEqT::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEqT does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEqT does not use op4p()");
    break;
}
case VNType::atEqWild: {
    const AstEqWild* const currp = static_cast<const AstEqWild*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstEqWild must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstEqWild::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstEqWild must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstEqWild::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEqWild does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEqWild does not use op4p()");
    break;
}
case VNType::atEventControl: {
    const AstEventControl* const currp = static_cast<const AstEventControl*>(this);
    // Checking op1p
    if (AstSenTree* const opp = currp->sensesp()) {
        UASSERT_OBJ(!currp->sensesp()->nextp(), currp, "AstEventControl::sensesp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstEventControl does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstEventControl does not use op4p()");
    break;
}
case VNType::atExecGraph: {
    const AstExecGraph* const currp = static_cast<const AstExecGraph*>(this);
    // Checking op1p
    if (const AstMTaskBody* const headp = currp->mTaskBodiesp()) {
        const AstNode* backp = currp;
        const AstMTaskBody* tailp = headp;
        const AstMTaskBody* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), MTaskBody);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstExecGraph does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstExecGraph does not use op4p()");
    break;
}
case VNType::atExpD: {
    const AstExpD* const currp = static_cast<const AstExpD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstExpD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstExpD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstExpD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstExpD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstExpD does not use op4p()");
    break;
}
case VNType::atExprStmt: {
    const AstExprStmt* const currp = static_cast<const AstExprStmt*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(currp->resultp(), currp, "AstExprStmt must have non nullptr resultp()");
    UASSERT_OBJ(!currp->resultp()->nextp(), currp, "AstExprStmt::resultp() cannot have a non nullptr nextp()");
    currp->resultp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstExprStmt does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstExprStmt does not use op4p()");
    break;
}
case VNType::atExtend: {
    const AstExtend* const currp = static_cast<const AstExtend*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstExtend must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstExtend::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstExtend does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstExtend does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstExtend does not use op4p()");
    break;
}
case VNType::atExtendS: {
    const AstExtendS* const currp = static_cast<const AstExtendS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstExtendS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstExtendS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstExtendS does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstExtendS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstExtendS does not use op4p()");
    break;
}
case VNType::atFClose: {
    const AstFClose* const currp = static_cast<const AstFClose*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->filep(), currp, "AstFClose must have non nullptr filep()");
    UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFClose::filep() cannot have a non nullptr nextp()");
    currp->filep()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFClose does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFClose does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFClose does not use op4p()");
    break;
}
case VNType::atFEof: {
    const AstFEof* const currp = static_cast<const AstFEof*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstFEof must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstFEof::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFEof does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFEof does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFEof does not use op4p()");
    break;
}
case VNType::atFError: {
    const AstFError* const currp = static_cast<const AstFError*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->filep(), currp, "AstFError must have non nullptr filep()");
    UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFError::filep() cannot have a non nullptr nextp()");
    currp->filep()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->strp(), currp, "AstFError must have non nullptr strp()");
    UASSERT_OBJ(!currp->strp()->nextp(), currp, "AstFError::strp() cannot have a non nullptr nextp()");
    currp->strp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFError does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFError does not use op4p()");
    break;
}
case VNType::atFFlush: {
    const AstFFlush* const currp = static_cast<const AstFFlush*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->filep()) {
        UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFFlush::filep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFFlush does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFFlush does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFFlush does not use op4p()");
    break;
}
case VNType::atFGetC: {
    const AstFGetC* const currp = static_cast<const AstFGetC*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstFGetC must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstFGetC::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFGetC does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFGetC does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFGetC does not use op4p()");
    break;
}
case VNType::atFGetS: {
    const AstFGetS* const currp = static_cast<const AstFGetS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstFGetS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstFGetS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstFGetS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstFGetS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFGetS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFGetS does not use op4p()");
    break;
}
case VNType::atFOpen: {
    const AstFOpen* const currp = static_cast<const AstFOpen*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstFOpen does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(currp->filenamep(), currp, "AstFOpen must have non nullptr filenamep()");
    UASSERT_OBJ(!currp->filenamep()->nextp(), currp, "AstFOpen::filenamep() cannot have a non nullptr nextp()");
    currp->filenamep()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->modep(), currp, "AstFOpen must have non nullptr modep()");
    UASSERT_OBJ(!currp->modep()->nextp(), currp, "AstFOpen::modep() cannot have a non nullptr nextp()");
    currp->modep()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFOpen does not use op4p()");
    break;
}
case VNType::atFOpenMcd: {
    const AstFOpenMcd* const currp = static_cast<const AstFOpenMcd*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstFOpenMcd does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(currp->filenamep(), currp, "AstFOpenMcd must have non nullptr filenamep()");
    UASSERT_OBJ(!currp->filenamep()->nextp(), currp, "AstFOpenMcd::filenamep() cannot have a non nullptr nextp()");
    currp->filenamep()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFOpenMcd does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFOpenMcd does not use op4p()");
    break;
}
case VNType::atFRead: {
    const AstFRead* const currp = static_cast<const AstFRead*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->memp(), currp, "AstFRead must have non nullptr memp()");
    UASSERT_OBJ(!currp->memp()->nextp(), currp, "AstFRead::memp() cannot have a non nullptr nextp()");
    currp->memp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->filep(), currp, "AstFRead must have non nullptr filep()");
    UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFRead::filep() cannot have a non nullptr nextp()");
    currp->filep()->checkTreeIter(currp);
    // Checking op3p
    if (AstNode* const opp = currp->startp()) {
        UASSERT_OBJ(!currp->startp()->nextp(), currp, "AstFRead::startp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstNode* const opp = currp->countp()) {
        UASSERT_OBJ(!currp->countp()->nextp(), currp, "AstFRead::countp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atFRewind: {
    const AstFRewind* const currp = static_cast<const AstFRewind*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->filep()) {
        UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFRewind::filep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFRewind does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFRewind does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFRewind does not use op4p()");
    break;
}
case VNType::atFScanF: {
    const AstFScanF* const currp = static_cast<const AstFScanF*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (AstNode* const opp = currp->filep()) {
        UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFScanF::filep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFScanF does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFScanF does not use op4p()");
    break;
}
case VNType::atFSeek: {
    const AstFSeek* const currp = static_cast<const AstFSeek*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->filep(), currp, "AstFSeek must have non nullptr filep()");
    UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFSeek::filep() cannot have a non nullptr nextp()");
    currp->filep()->checkTreeIter(currp);
    // Checking op2p
    if (AstNode* const opp = currp->offset()) {
        UASSERT_OBJ(!currp->offset()->nextp(), currp, "AstFSeek::offset() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (AstNode* const opp = currp->operation()) {
        UASSERT_OBJ(!currp->operation()->nextp(), currp, "AstFSeek::operation() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFSeek does not use op4p()");
    break;
}
case VNType::atFTell: {
    const AstFTell* const currp = static_cast<const AstFTell*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->filep(), currp, "AstFTell must have non nullptr filep()");
    UASSERT_OBJ(!currp->filep()->nextp(), currp, "AstFTell::filep() cannot have a non nullptr nextp()");
    currp->filep()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFTell does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFTell does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFTell does not use op4p()");
    break;
}
case VNType::atFUngetC: {
    const AstFUngetC* const currp = static_cast<const AstFUngetC*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstFUngetC must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstFUngetC::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstFUngetC must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstFUngetC::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFUngetC does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFUngetC does not use op4p()");
    break;
}
case VNType::atFell: {
    const AstFell* const currp = static_cast<const AstFell*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstFell must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstFell::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstFell::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFell does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFell does not use op4p()");
    break;
}
case VNType::atFinal: {
    const AstFinal* const currp = static_cast<const AstFinal*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstFinal does not use op1p()");
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFinal does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFinal does not use op4p()");
    break;
}
case VNType::atFinish: {
    const AstFinish* const currp = static_cast<const AstFinish*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstFinish does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFinish does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFinish does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFinish does not use op4p()");
    break;
}
case VNType::atFireEvent: {
    const AstFireEvent* const currp = static_cast<const AstFireEvent*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->operandp(), currp, "AstFireEvent must have non nullptr operandp()");
    UASSERT_OBJ(!currp->operandp()->nextp(), currp, "AstFireEvent::operandp() cannot have a non nullptr nextp()");
    currp->operandp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFireEvent does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFireEvent does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFireEvent does not use op4p()");
    break;
}
case VNType::atFloorD: {
    const AstFloorD* const currp = static_cast<const AstFloorD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstFloorD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstFloorD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFloorD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFloorD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFloorD does not use op4p()");
    break;
}
case VNType::atForeach: {
    const AstForeach* const currp = static_cast<const AstForeach*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->arrayp(), currp, "AstForeach must have non nullptr arrayp()");
    UASSERT_OBJ(!currp->arrayp()->nextp(), currp, "AstForeach::arrayp() cannot have a non nullptr nextp()");
    currp->arrayp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstForeach does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstForeach does not use op4p()");
    break;
}
case VNType::atFork: {
    const AstFork* const currp = static_cast<const AstFork*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFork does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstFork does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstFork does not use op4p()");
    break;
}
case VNType::atFunc: {
    const AstFunc* const currp = static_cast<const AstFunc*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->fvarp()) {
        UASSERT_OBJ(!currp->fvarp()->nextp(), currp, "AstFunc::fvarp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNode* const opp = currp->classOrPackagep()) {
        UASSERT_OBJ(!currp->classOrPackagep()->nextp(), currp, "AstFunc::classOrPackagep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstFunc::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atFuncRef: {
    const AstFuncRef* const currp = static_cast<const AstFuncRef*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->namep()) {
        UASSERT_OBJ(!currp->namep()->nextp(), currp, "AstFuncRef::namep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstFuncRef does not use op2p()");
    // Checking op3p
    if (const AstNodeExpr* const headp = currp->pinsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstFuncRef::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atGatePin: {
    const AstGatePin* const currp = static_cast<const AstGatePin*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstGatePin must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstGatePin::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rangep(), currp, "AstGatePin must have non nullptr rangep()");
    UASSERT_OBJ(!currp->rangep()->nextp(), currp, "AstGatePin::rangep() cannot have a non nullptr nextp()");
    currp->rangep()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGatePin does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGatePin does not use op4p()");
    break;
}
case VNType::atGenCase: {
    const AstGenCase* const currp = static_cast<const AstGenCase*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstGenCase must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstGenCase::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstCaseItem* const headp = currp->itemsp()) {
        const AstNode* backp = currp;
        const AstCaseItem* tailp = headp;
        const AstCaseItem* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), CaseItem);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstNode* const headp = currp->notParallelp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGenCase does not use op4p()");
    break;
}
case VNType::atGenFor: {
    const AstGenFor* const currp = static_cast<const AstGenFor*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->initsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(currp->condp(), currp, "AstGenFor must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstGenFor::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op3p
    if (const AstNode* const headp = currp->incsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atGenIf: {
    const AstGenIf* const currp = static_cast<const AstGenIf*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->condp(), currp, "AstGenIf must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstGenIf::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->thensp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstNode* const headp = currp->elsesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGenIf does not use op4p()");
    break;
}
case VNType::atGetcN: {
    const AstGetcN* const currp = static_cast<const AstGetcN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGetcN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGetcN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGetcN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGetcN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGetcN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGetcN does not use op4p()");
    break;
}
case VNType::atGetcRefN: {
    const AstGetcRefN* const currp = static_cast<const AstGetcRefN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGetcRefN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGetcRefN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGetcRefN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGetcRefN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGetcRefN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGetcRefN does not use op4p()");
    break;
}
case VNType::atGt: {
    const AstGt* const currp = static_cast<const AstGt*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGt must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGt::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGt must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGt::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGt does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGt does not use op4p()");
    break;
}
case VNType::atGtD: {
    const AstGtD* const currp = static_cast<const AstGtD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGtD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGtD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGtD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGtD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGtD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGtD does not use op4p()");
    break;
}
case VNType::atGtN: {
    const AstGtN* const currp = static_cast<const AstGtN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGtN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGtN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGtN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGtN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGtN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGtN does not use op4p()");
    break;
}
case VNType::atGtS: {
    const AstGtS* const currp = static_cast<const AstGtS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGtS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGtS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGtS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGtS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGtS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGtS does not use op4p()");
    break;
}
case VNType::atGte: {
    const AstGte* const currp = static_cast<const AstGte*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGte must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGte::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGte must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGte::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGte does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGte does not use op4p()");
    break;
}
case VNType::atGteD: {
    const AstGteD* const currp = static_cast<const AstGteD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGteD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGteD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGteD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGteD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGteD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGteD does not use op4p()");
    break;
}
case VNType::atGteN: {
    const AstGteN* const currp = static_cast<const AstGteN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGteN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGteN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGteN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGteN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGteN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGteN does not use op4p()");
    break;
}
case VNType::atGteS: {
    const AstGteS* const currp = static_cast<const AstGteS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstGteS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstGteS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstGteS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstGteS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstGteS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstGteS does not use op4p()");
    break;
}
case VNType::atHypotD: {
    const AstHypotD* const currp = static_cast<const AstHypotD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstHypotD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstHypotD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstHypotD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstHypotD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstHypotD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstHypotD does not use op4p()");
    break;
}
case VNType::atISToRD: {
    const AstISToRD* const currp = static_cast<const AstISToRD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstISToRD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstISToRD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstISToRD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstISToRD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstISToRD does not use op4p()");
    break;
}
case VNType::atIToRD: {
    const AstIToRD* const currp = static_cast<const AstIToRD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstIToRD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstIToRD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstIToRD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstIToRD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstIToRD does not use op4p()");
    break;
}
case VNType::atIf: {
    const AstIf* const currp = static_cast<const AstIf*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->condp(), currp, "AstIf must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstIf::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->thensp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstNode* const headp = currp->elsesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstIf does not use op4p()");
    break;
}
case VNType::atIface: {
    const AstIface* const currp = static_cast<const AstIface*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->inlinesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstActive* const headp = currp->activesp()) {
        const AstNode* backp = currp;
        const AstActive* tailp = headp;
        const AstActive* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Active);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstIface does not use op4p()");
    break;
}
case VNType::atIfaceRefDType: {
    const AstIfaceRefDType* const currp = static_cast<const AstIfaceRefDType*>(this);
    // Checking op1p
    if (const AstPin* const headp = currp->paramsp()) {
        const AstNode* backp = currp;
        const AstPin* tailp = headp;
        const AstPin* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Pin);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstIfaceRefDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstIfaceRefDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstIfaceRefDType does not use op4p()");
    break;
}
case VNType::atImplication: {
    const AstImplication* const currp = static_cast<const AstImplication*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstImplication must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstImplication::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstImplication must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstImplication::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstImplication::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstImplication does not use op4p()");
    break;
}
case VNType::atImplicit: {
    const AstImplicit* const currp = static_cast<const AstImplicit*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstImplicit does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstImplicit does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstImplicit does not use op4p()");
    break;
}
case VNType::atInitArray: {
    const AstInitArray* const currp = static_cast<const AstInitArray*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->defaultp()) {
        UASSERT_OBJ(!currp->defaultp()->nextp(), currp, "AstInitArray::defaultp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->initsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstInitArray does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstInitArray does not use op4p()");
    break;
}
case VNType::atInitItem: {
    const AstInitItem* const currp = static_cast<const AstInitItem*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->valuep(), currp, "AstInitItem must have non nullptr valuep()");
    UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstInitItem::valuep() cannot have a non nullptr nextp()");
    currp->valuep()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstInitItem does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstInitItem does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstInitItem does not use op4p()");
    break;
}
case VNType::atInitial: {
    const AstInitial* const currp = static_cast<const AstInitial*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstInitial does not use op1p()");
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstInitial does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstInitial does not use op4p()");
    break;
}
case VNType::atInitialAutomatic: {
    const AstInitialAutomatic* const currp = static_cast<const AstInitialAutomatic*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstInitialAutomatic does not use op1p()");
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstInitialAutomatic does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstInitialAutomatic does not use op4p()");
    break;
}
case VNType::atInitialStatic: {
    const AstInitialStatic* const currp = static_cast<const AstInitialStatic*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstInitialStatic does not use op1p()");
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstInitialStatic does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstInitialStatic does not use op4p()");
    break;
}
case VNType::atInside: {
    const AstInside* const currp = static_cast<const AstInside*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstInside must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstInside::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNodeExpr* const headp = currp->itemsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstInside does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstInside does not use op4p()");
    break;
}
case VNType::atInsideRange: {
    const AstInsideRange* const currp = static_cast<const AstInsideRange*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstInsideRange must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstInsideRange::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstInsideRange must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstInsideRange::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstInsideRange does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstInsideRange does not use op4p()");
    break;
}
case VNType::atIntfRef: {
    const AstIntfRef* const currp = static_cast<const AstIntfRef*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstIntfRef does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstIntfRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstIntfRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstIntfRef does not use op4p()");
    break;
}
case VNType::atIsUnbounded: {
    const AstIsUnbounded* const currp = static_cast<const AstIsUnbounded*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstIsUnbounded must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstIsUnbounded::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstIsUnbounded does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstIsUnbounded does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstIsUnbounded does not use op4p()");
    break;
}
case VNType::atIsUnknown: {
    const AstIsUnknown* const currp = static_cast<const AstIsUnknown*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstIsUnknown must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstIsUnknown::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstIsUnknown does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstIsUnknown does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstIsUnknown does not use op4p()");
    break;
}
case VNType::atJumpBlock: {
    const AstJumpBlock* const currp = static_cast<const AstJumpBlock*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->endStmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstJumpBlock does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstJumpBlock does not use op4p()");
    break;
}
case VNType::atJumpGo: {
    const AstJumpGo* const currp = static_cast<const AstJumpGo*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstJumpGo does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstJumpGo does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstJumpGo does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstJumpGo does not use op4p()");
    break;
}
case VNType::atJumpLabel: {
    const AstJumpLabel* const currp = static_cast<const AstJumpLabel*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstJumpLabel does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstJumpLabel does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstJumpLabel does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstJumpLabel does not use op4p()");
    break;
}
case VNType::atLambdaArgRef: {
    const AstLambdaArgRef* const currp = static_cast<const AstLambdaArgRef*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstLambdaArgRef does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstLambdaArgRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLambdaArgRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLambdaArgRef does not use op4p()");
    break;
}
case VNType::atLenN: {
    const AstLenN* const currp = static_cast<const AstLenN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLenN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLenN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstLenN does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLenN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLenN does not use op4p()");
    break;
}
case VNType::atLog10D: {
    const AstLog10D* const currp = static_cast<const AstLog10D*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLog10D must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLog10D::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstLog10D does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLog10D does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLog10D does not use op4p()");
    break;
}
case VNType::atLogAnd: {
    const AstLogAnd* const currp = static_cast<const AstLogAnd*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLogAnd must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLogAnd::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLogAnd must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLogAnd::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLogAnd does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLogAnd does not use op4p()");
    break;
}
case VNType::atLogD: {
    const AstLogD* const currp = static_cast<const AstLogD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLogD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLogD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstLogD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLogD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLogD does not use op4p()");
    break;
}
case VNType::atLogEq: {
    const AstLogEq* const currp = static_cast<const AstLogEq*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLogEq must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLogEq::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLogEq must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLogEq::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLogEq does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLogEq does not use op4p()");
    break;
}
case VNType::atLogIf: {
    const AstLogIf* const currp = static_cast<const AstLogIf*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLogIf must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLogIf::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLogIf must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLogIf::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLogIf does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLogIf does not use op4p()");
    break;
}
case VNType::atLogNot: {
    const AstLogNot* const currp = static_cast<const AstLogNot*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLogNot must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLogNot::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstLogNot does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLogNot does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLogNot does not use op4p()");
    break;
}
case VNType::atLogOr: {
    const AstLogOr* const currp = static_cast<const AstLogOr*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLogOr must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLogOr::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLogOr must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLogOr::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLogOr does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLogOr does not use op4p()");
    break;
}
case VNType::atLt: {
    const AstLt* const currp = static_cast<const AstLt*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLt must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLt::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLt must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLt::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLt does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLt does not use op4p()");
    break;
}
case VNType::atLtD: {
    const AstLtD* const currp = static_cast<const AstLtD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLtD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLtD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLtD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLtD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLtD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLtD does not use op4p()");
    break;
}
case VNType::atLtN: {
    const AstLtN* const currp = static_cast<const AstLtN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLtN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLtN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLtN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLtN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLtN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLtN does not use op4p()");
    break;
}
case VNType::atLtS: {
    const AstLtS* const currp = static_cast<const AstLtS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLtS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLtS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLtS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLtS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLtS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLtS does not use op4p()");
    break;
}
case VNType::atLte: {
    const AstLte* const currp = static_cast<const AstLte*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLte must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLte::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLte must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLte::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLte does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLte does not use op4p()");
    break;
}
case VNType::atLteD: {
    const AstLteD* const currp = static_cast<const AstLteD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLteD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLteD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLteD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLteD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLteD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLteD does not use op4p()");
    break;
}
case VNType::atLteN: {
    const AstLteN* const currp = static_cast<const AstLteN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLteN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLteN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLteN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLteN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLteN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLteN does not use op4p()");
    break;
}
case VNType::atLteS: {
    const AstLteS* const currp = static_cast<const AstLteS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstLteS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstLteS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstLteS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstLteS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstLteS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstLteS does not use op4p()");
    break;
}
case VNType::atMTaskBody: {
    const AstMTaskBody* const currp = static_cast<const AstMTaskBody*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstMTaskBody does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstMTaskBody does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstMTaskBody does not use op4p()");
    break;
}
case VNType::atMemberDType: {
    const AstMemberDType* const currp = static_cast<const AstMemberDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstMemberDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstMemberDType does not use op2p()");
    // Checking op3p
    if (AstNode* const opp = currp->valuep()) {
        UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstMemberDType::valuep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstMemberDType does not use op4p()");
    break;
}
case VNType::atMemberSel: {
    const AstMemberSel* const currp = static_cast<const AstMemberSel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstMemberSel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstMemberSel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstMemberSel does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstMemberSel does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstMemberSel does not use op4p()");
    break;
}
case VNType::atMethodCall: {
    const AstMethodCall* const currp = static_cast<const AstMethodCall*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->namep()) {
        UASSERT_OBJ(!currp->namep()->nextp(), currp, "AstMethodCall::namep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(currp->fromp(), currp, "AstMethodCall must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstMethodCall::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op3p
    if (const AstNodeExpr* const headp = currp->pinsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstMethodCall::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atModDiv: {
    const AstModDiv* const currp = static_cast<const AstModDiv*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstModDiv must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstModDiv::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstModDiv must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstModDiv::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstModDiv does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstModDiv does not use op4p()");
    break;
}
case VNType::atModDivS: {
    const AstModDivS* const currp = static_cast<const AstModDivS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstModDivS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstModDivS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstModDivS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstModDivS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstModDivS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstModDivS does not use op4p()");
    break;
}
case VNType::atModport: {
    const AstModport* const currp = static_cast<const AstModport*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->varsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstModport does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstModport does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstModport does not use op4p()");
    break;
}
case VNType::atModportFTaskRef: {
    const AstModportFTaskRef* const currp = static_cast<const AstModportFTaskRef*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstModportFTaskRef does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstModportFTaskRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstModportFTaskRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstModportFTaskRef does not use op4p()");
    break;
}
case VNType::atModportVarRef: {
    const AstModportVarRef* const currp = static_cast<const AstModportVarRef*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstModportVarRef does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstModportVarRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstModportVarRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstModportVarRef does not use op4p()");
    break;
}
case VNType::atModule: {
    const AstModule* const currp = static_cast<const AstModule*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->inlinesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstActive* const headp = currp->activesp()) {
        const AstNode* backp = currp;
        const AstActive* tailp = headp;
        const AstActive* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Active);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstModule does not use op4p()");
    break;
}
case VNType::atMonitorOff: {
    const AstMonitorOff* const currp = static_cast<const AstMonitorOff*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstMonitorOff does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstMonitorOff does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstMonitorOff does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstMonitorOff does not use op4p()");
    break;
}
case VNType::atMul: {
    const AstMul* const currp = static_cast<const AstMul*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstMul must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstMul::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstMul must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstMul::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstMul does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstMul does not use op4p()");
    break;
}
case VNType::atMulD: {
    const AstMulD* const currp = static_cast<const AstMulD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstMulD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstMulD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstMulD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstMulD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstMulD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstMulD does not use op4p()");
    break;
}
case VNType::atMulS: {
    const AstMulS* const currp = static_cast<const AstMulS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstMulS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstMulS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstMulS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstMulS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstMulS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstMulS does not use op4p()");
    break;
}
case VNType::atNToI: {
    const AstNToI* const currp = static_cast<const AstNToI*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNToI must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNToI::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstNToI does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNToI does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNToI does not use op4p()");
    break;
}
case VNType::atNegate: {
    const AstNegate* const currp = static_cast<const AstNegate*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNegate must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNegate::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstNegate does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNegate does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNegate does not use op4p()");
    break;
}
case VNType::atNegateD: {
    const AstNegateD* const currp = static_cast<const AstNegateD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNegateD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNegateD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstNegateD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNegateD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNegateD does not use op4p()");
    break;
}
case VNType::atNeq: {
    const AstNeq* const currp = static_cast<const AstNeq*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNeq must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNeq::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstNeq must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNeq::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNeq does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNeq does not use op4p()");
    break;
}
case VNType::atNeqCase: {
    const AstNeqCase* const currp = static_cast<const AstNeqCase*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNeqCase must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNeqCase::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstNeqCase must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNeqCase::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNeqCase does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNeqCase does not use op4p()");
    break;
}
case VNType::atNeqD: {
    const AstNeqD* const currp = static_cast<const AstNeqD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNeqD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNeqD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstNeqD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNeqD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNeqD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNeqD does not use op4p()");
    break;
}
case VNType::atNeqN: {
    const AstNeqN* const currp = static_cast<const AstNeqN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNeqN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNeqN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstNeqN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNeqN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNeqN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNeqN does not use op4p()");
    break;
}
case VNType::atNeqT: {
    const AstNeqT* const currp = static_cast<const AstNeqT*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNeqT must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNeqT::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstNeqT must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNeqT::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNeqT does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNeqT does not use op4p()");
    break;
}
case VNType::atNeqWild: {
    const AstNeqWild* const currp = static_cast<const AstNeqWild*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNeqWild must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNeqWild::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstNeqWild must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNeqWild::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNeqWild does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNeqWild does not use op4p()");
    break;
}
case VNType::atNetlist: {
    const AstNetlist* const currp = static_cast<const AstNetlist*>(this);
    // Checking op1p
    if (const AstNodeModule* const headp = currp->modulesp()) {
        const AstNode* backp = currp;
        const AstNodeModule* tailp = headp;
        const AstNodeModule* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeModule);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNodeFile* const headp = currp->filesp()) {
        const AstNode* backp = currp;
        const AstNodeFile* tailp = headp;
        const AstNodeFile* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeFile);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstNode* const headp = currp->miscsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNetlist does not use op4p()");
    break;
}
case VNType::atNew: {
    const AstNew* const currp = static_cast<const AstNew*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->namep()) {
        UASSERT_OBJ(!currp->namep()->nextp(), currp, "AstNew::namep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstNew does not use op2p()");
    // Checking op3p
    if (const AstNodeExpr* const headp = currp->pinsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstNew::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atNewCopy: {
    const AstNewCopy* const currp = static_cast<const AstNewCopy*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->rhsp(), currp, "AstNewCopy must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNewCopy::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstNewCopy does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNewCopy does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNewCopy does not use op4p()");
    break;
}
case VNType::atNewDynamic: {
    const AstNewDynamic* const currp = static_cast<const AstNewDynamic*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->sizep(), currp, "AstNewDynamic must have non nullptr sizep()");
    UASSERT_OBJ(!currp->sizep()->nextp(), currp, "AstNewDynamic::sizep() cannot have a non nullptr nextp()");
    currp->sizep()->checkTreeIter(currp);
    // Checking op2p
    if (AstNodeExpr* const opp = currp->rhsp()) {
        UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstNewDynamic::rhsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNewDynamic does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNewDynamic does not use op4p()");
    break;
}
case VNType::atNot: {
    const AstNot* const currp = static_cast<const AstNot*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNot must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNot::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstNot does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNot does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNot does not use op4p()");
    break;
}
case VNType::atNotFoundModule: {
    const AstNotFoundModule* const currp = static_cast<const AstNotFoundModule*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->inlinesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstActive* const headp = currp->activesp()) {
        const AstNode* backp = currp;
        const AstActive* tailp = headp;
        const AstActive* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Active);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNotFoundModule does not use op4p()");
    break;
}
case VNType::atNullCheck: {
    const AstNullCheck* const currp = static_cast<const AstNullCheck*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstNullCheck must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstNullCheck::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstNullCheck does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstNullCheck does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstNullCheck does not use op4p()");
    break;
}
case VNType::atOneHot: {
    const AstOneHot* const currp = static_cast<const AstOneHot*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstOneHot must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstOneHot::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstOneHot does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstOneHot does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstOneHot does not use op4p()");
    break;
}
case VNType::atOneHot0: {
    const AstOneHot0* const currp = static_cast<const AstOneHot0*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstOneHot0 must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstOneHot0::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstOneHot0 does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstOneHot0 does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstOneHot0 does not use op4p()");
    break;
}
case VNType::atOr: {
    const AstOr* const currp = static_cast<const AstOr*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstOr must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstOr::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstOr must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstOr::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstOr does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstOr does not use op4p()");
    break;
}
case VNType::atPackArrayDType: {
    const AstPackArrayDType* const currp = static_cast<const AstPackArrayDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstPackArrayDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstRange* const opp = currp->rangep()) {
        UASSERT_OBJ(!currp->rangep()->nextp(), currp, "AstPackArrayDType::rangep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPackArrayDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPackArrayDType does not use op4p()");
    break;
}
case VNType::atPackage: {
    const AstPackage* const currp = static_cast<const AstPackage*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->inlinesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstActive* const headp = currp->activesp()) {
        const AstNode* backp = currp;
        const AstActive* tailp = headp;
        const AstActive* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Active);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPackage does not use op4p()");
    break;
}
case VNType::atPackageExport: {
    const AstPackageExport* const currp = static_cast<const AstPackageExport*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstPackageExport does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPackageExport does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPackageExport does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPackageExport does not use op4p()");
    break;
}
case VNType::atPackageExportStarStar: {
    const AstPackageExportStarStar* const currp = static_cast<const AstPackageExportStarStar*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstPackageExportStarStar does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPackageExportStarStar does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPackageExportStarStar does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPackageExportStarStar does not use op4p()");
    break;
}
case VNType::atPackageImport: {
    const AstPackageImport* const currp = static_cast<const AstPackageImport*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstPackageImport does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPackageImport does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPackageImport does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPackageImport does not use op4p()");
    break;
}
case VNType::atParamTypeDType: {
    const AstParamTypeDType* const currp = static_cast<const AstParamTypeDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstParamTypeDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstParamTypeDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstParamTypeDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstParamTypeDType does not use op4p()");
    break;
}
case VNType::atParseRef: {
    const AstParseRef* const currp = static_cast<const AstParseRef*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->lhsp()) {
        UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstParseRef::lhsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeFTaskRef* const opp = currp->ftaskrefp()) {
        UASSERT_OBJ(!currp->ftaskrefp()->nextp(), currp, "AstParseRef::ftaskrefp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstParseRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstParseRef does not use op4p()");
    break;
}
case VNType::atParseTypeDType: {
    const AstParseTypeDType* const currp = static_cast<const AstParseTypeDType*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstParseTypeDType does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstParseTypeDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstParseTypeDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstParseTypeDType does not use op4p()");
    break;
}
case VNType::atPast: {
    const AstPast* const currp = static_cast<const AstPast*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstPast must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstPast::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    if (AstNode* const opp = currp->ticksp()) {
        UASSERT_OBJ(!currp->ticksp()->nextp(), currp, "AstPast::ticksp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstPast::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPast does not use op4p()");
    break;
}
case VNType::atPatMember: {
    const AstPatMember* const currp = static_cast<const AstPatMember*>(this);
    // Checking op1p
    if (const AstNodeExpr* const headp = currp->lhssp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (AstNode* const opp = currp->keyp()) {
        UASSERT_OBJ(!currp->keyp()->nextp(), currp, "AstPatMember::keyp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (AstNodeExpr* const opp = currp->repp()) {
        UASSERT_OBJ(!currp->repp()->nextp(), currp, "AstPatMember::repp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPatMember does not use op4p()");
    break;
}
case VNType::atPattern: {
    const AstPattern* const currp = static_cast<const AstPattern*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstPattern::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (const AstNode* const headp = currp->itemsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPattern does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPattern does not use op4p()");
    break;
}
case VNType::atPin: {
    const AstPin* const currp = static_cast<const AstPin*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->exprp()) {
        UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstPin::exprp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPin does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPin does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPin does not use op4p()");
    break;
}
case VNType::atPort: {
    const AstPort* const currp = static_cast<const AstPort*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->exprp()) {
        UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstPort::exprp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPort does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPort does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPort does not use op4p()");
    break;
}
case VNType::atPostAdd: {
    const AstPostAdd* const currp = static_cast<const AstPostAdd*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPostAdd must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPostAdd::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPostAdd must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPostAdd::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstPostAdd must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstPostAdd::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPostAdd does not use op4p()");
    break;
}
case VNType::atPostSub: {
    const AstPostSub* const currp = static_cast<const AstPostSub*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPostSub must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPostSub::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPostSub must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPostSub::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstPostSub must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstPostSub::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPostSub does not use op4p()");
    break;
}
case VNType::atPow: {
    const AstPow* const currp = static_cast<const AstPow*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPow must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPow::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPow must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPow::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPow does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPow does not use op4p()");
    break;
}
case VNType::atPowD: {
    const AstPowD* const currp = static_cast<const AstPowD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPowD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPowD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPowD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPowD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPowD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPowD does not use op4p()");
    break;
}
case VNType::atPowSS: {
    const AstPowSS* const currp = static_cast<const AstPowSS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPowSS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPowSS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPowSS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPowSS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPowSS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPowSS does not use op4p()");
    break;
}
case VNType::atPowSU: {
    const AstPowSU* const currp = static_cast<const AstPowSU*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPowSU must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPowSU::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPowSU must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPowSU::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPowSU does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPowSU does not use op4p()");
    break;
}
case VNType::atPowUS: {
    const AstPowUS* const currp = static_cast<const AstPowUS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPowUS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPowUS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPowUS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPowUS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPowUS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPowUS does not use op4p()");
    break;
}
case VNType::atPragma: {
    const AstPragma* const currp = static_cast<const AstPragma*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstPragma does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPragma does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPragma does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPragma does not use op4p()");
    break;
}
case VNType::atPreAdd: {
    const AstPreAdd* const currp = static_cast<const AstPreAdd*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPreAdd must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPreAdd::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPreAdd must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPreAdd::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstPreAdd must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstPreAdd::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPreAdd does not use op4p()");
    break;
}
case VNType::atPreSub: {
    const AstPreSub* const currp = static_cast<const AstPreSub*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPreSub must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPreSub::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPreSub must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPreSub::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstPreSub must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstPreSub::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPreSub does not use op4p()");
    break;
}
case VNType::atPrimitive: {
    const AstPrimitive* const currp = static_cast<const AstPrimitive*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->inlinesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    if (const AstActive* const headp = currp->activesp()) {
        const AstNode* backp = currp;
        const AstActive* tailp = headp;
        const AstActive* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Active);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPrimitive does not use op4p()");
    break;
}
case VNType::atPrintTimeScale: {
    const AstPrintTimeScale* const currp = static_cast<const AstPrintTimeScale*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstPrintTimeScale does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPrintTimeScale does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPrintTimeScale does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPrintTimeScale does not use op4p()");
    break;
}
case VNType::atPropSpec: {
    const AstPropSpec* const currp = static_cast<const AstPropSpec*>(this);
    // Checking op1p
    if (AstSenItem* const opp = currp->sensesp()) {
        UASSERT_OBJ(!currp->sensesp()->nextp(), currp, "AstPropSpec::sensesp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeExpr* const opp = currp->disablep()) {
        UASSERT_OBJ(!currp->disablep()->nextp(), currp, "AstPropSpec::disablep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(currp->propp(), currp, "AstPropSpec must have non nullptr propp()");
    UASSERT_OBJ(!currp->propp()->nextp(), currp, "AstPropSpec::propp() cannot have a non nullptr nextp()");
    currp->propp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPropSpec does not use op4p()");
    break;
}
case VNType::atProperty: {
    const AstProperty* const currp = static_cast<const AstProperty*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->fvarp()) {
        UASSERT_OBJ(!currp->fvarp()->nextp(), currp, "AstProperty::fvarp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNode* const opp = currp->classOrPackagep()) {
        UASSERT_OBJ(!currp->classOrPackagep()->nextp(), currp, "AstProperty::classOrPackagep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstProperty::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atPull: {
    const AstPull* const currp = static_cast<const AstPull*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPull must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPull::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstPull does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstPull does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPull does not use op4p()");
    break;
}
case VNType::atPutcN: {
    const AstPutcN* const currp = static_cast<const AstPutcN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstPutcN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstPutcN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstPutcN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstPutcN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstPutcN must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstPutcN::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstPutcN does not use op4p()");
    break;
}
case VNType::atQueueDType: {
    const AstQueueDType* const currp = static_cast<const AstQueueDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstQueueDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeExpr* const opp = currp->boundp()) {
        UASSERT_OBJ(!currp->boundp()->nextp(), currp, "AstQueueDType::boundp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstQueueDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstQueueDType does not use op4p()");
    break;
}
case VNType::atRToIRoundS: {
    const AstRToIRoundS* const currp = static_cast<const AstRToIRoundS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstRToIRoundS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstRToIRoundS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRToIRoundS does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRToIRoundS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRToIRoundS does not use op4p()");
    break;
}
case VNType::atRToIS: {
    const AstRToIS* const currp = static_cast<const AstRToIS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstRToIS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstRToIS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRToIS does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRToIS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRToIS does not use op4p()");
    break;
}
case VNType::atRand: {
    const AstRand* const currp = static_cast<const AstRand*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->seedp()) {
        UASSERT_OBJ(!currp->seedp()->nextp(), currp, "AstRand::seedp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRand does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRand does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRand does not use op4p()");
    break;
}
case VNType::atRandCase: {
    const AstRandCase* const currp = static_cast<const AstRandCase*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstRandCase does not use op1p()");
    // Checking op2p
    if (const AstCaseItem* const headp = currp->itemsp()) {
        const AstNode* backp = currp;
        const AstCaseItem* tailp = headp;
        const AstCaseItem* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), CaseItem);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRandCase does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRandCase does not use op4p()");
    break;
}
case VNType::atRandRNG: {
    const AstRandRNG* const currp = static_cast<const AstRandRNG*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstRandRNG does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRandRNG does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRandRNG does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRandRNG does not use op4p()");
    break;
}
case VNType::atRange: {
    const AstRange* const currp = static_cast<const AstRange*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->leftp(), currp, "AstRange must have non nullptr leftp()");
    UASSERT_OBJ(!currp->leftp()->nextp(), currp, "AstRange::leftp() cannot have a non nullptr nextp()");
    currp->leftp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rightp(), currp, "AstRange must have non nullptr rightp()");
    UASSERT_OBJ(!currp->rightp()->nextp(), currp, "AstRange::rightp() cannot have a non nullptr nextp()");
    currp->rightp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRange does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRange does not use op4p()");
    break;
}
case VNType::atReadMem: {
    const AstReadMem* const currp = static_cast<const AstReadMem*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->filenamep(), currp, "AstReadMem must have non nullptr filenamep()");
    UASSERT_OBJ(!currp->filenamep()->nextp(), currp, "AstReadMem::filenamep() cannot have a non nullptr nextp()");
    currp->filenamep()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->memp(), currp, "AstReadMem must have non nullptr memp()");
    UASSERT_OBJ(!currp->memp()->nextp(), currp, "AstReadMem::memp() cannot have a non nullptr nextp()");
    currp->memp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNodeExpr* const opp = currp->lsbp()) {
        UASSERT_OBJ(!currp->lsbp()->nextp(), currp, "AstReadMem::lsbp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstNodeExpr* const opp = currp->msbp()) {
        UASSERT_OBJ(!currp->msbp()->nextp(), currp, "AstReadMem::msbp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atRealToBits: {
    const AstRealToBits* const currp = static_cast<const AstRealToBits*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstRealToBits must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstRealToBits::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRealToBits does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRealToBits does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRealToBits does not use op4p()");
    break;
}
case VNType::atRedAnd: {
    const AstRedAnd* const currp = static_cast<const AstRedAnd*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstRedAnd must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstRedAnd::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRedAnd does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRedAnd does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRedAnd does not use op4p()");
    break;
}
case VNType::atRedOr: {
    const AstRedOr* const currp = static_cast<const AstRedOr*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstRedOr must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstRedOr::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRedOr does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRedOr does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRedOr does not use op4p()");
    break;
}
case VNType::atRedXor: {
    const AstRedXor* const currp = static_cast<const AstRedXor*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstRedXor must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstRedXor::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRedXor does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRedXor does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRedXor does not use op4p()");
    break;
}
case VNType::atRefDType: {
    const AstRefDType* const currp = static_cast<const AstRefDType*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->typeofp()) {
        UASSERT_OBJ(!currp->typeofp()->nextp(), currp, "AstRefDType::typeofp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNodeExpr* const opp = currp->classOrPackageOpp()) {
        UASSERT_OBJ(!currp->classOrPackageOpp()->nextp(), currp, "AstRefDType::classOrPackageOpp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (const AstPin* const headp = currp->paramsp()) {
        const AstNode* backp = currp;
        const AstPin* tailp = headp;
        const AstPin* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Pin);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRefDType does not use op4p()");
    break;
}
case VNType::atRelease: {
    const AstRelease* const currp = static_cast<const AstRelease*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstRelease must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstRelease::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstRelease does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRelease does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRelease does not use op4p()");
    break;
}
case VNType::atRepeat: {
    const AstRepeat* const currp = static_cast<const AstRepeat*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->countp(), currp, "AstRepeat must have non nullptr countp()");
    UASSERT_OBJ(!currp->countp()->nextp(), currp, "AstRepeat::countp() cannot have a non nullptr nextp()");
    currp->countp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRepeat does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRepeat does not use op4p()");
    break;
}
case VNType::atReplicate: {
    const AstReplicate* const currp = static_cast<const AstReplicate*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->srcp(), currp, "AstReplicate must have non nullptr srcp()");
    UASSERT_OBJ(!currp->srcp()->nextp(), currp, "AstReplicate::srcp() cannot have a non nullptr nextp()");
    currp->srcp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->countp(), currp, "AstReplicate must have non nullptr countp()");
    UASSERT_OBJ(!currp->countp()->nextp(), currp, "AstReplicate::countp() cannot have a non nullptr nextp()");
    currp->countp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstReplicate does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstReplicate does not use op4p()");
    break;
}
case VNType::atReplicateN: {
    const AstReplicateN* const currp = static_cast<const AstReplicateN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstReplicateN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstReplicateN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstReplicateN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstReplicateN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstReplicateN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstReplicateN does not use op4p()");
    break;
}
case VNType::atRestrict: {
    const AstRestrict* const currp = static_cast<const AstRestrict*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->propp(), currp, "AstRestrict must have non nullptr propp()");
    UASSERT_OBJ(!currp->propp()->nextp(), currp, "AstRestrict::propp() cannot have a non nullptr nextp()");
    currp->propp()->checkTreeIter(currp);
    // Checking op2p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstRestrict::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRestrict does not use op3p()");
    // Checking op4p
    if (const AstNode* const headp = currp->passsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atReturn: {
    const AstReturn* const currp = static_cast<const AstReturn*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->lhsp()) {
        UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstReturn::lhsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstReturn does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstReturn does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstReturn does not use op4p()");
    break;
}
case VNType::atRose: {
    const AstRose* const currp = static_cast<const AstRose*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstRose must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstRose::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstRose::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstRose does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstRose does not use op4p()");
    break;
}
case VNType::atSFormat: {
    const AstSFormat* const currp = static_cast<const AstSFormat*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fmtp(), currp, "AstSFormat must have non nullptr fmtp()");
    UASSERT_OBJ(!currp->fmtp()->nextp(), currp, "AstSFormat::fmtp() cannot have a non nullptr nextp()");
    currp->fmtp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSFormat must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSFormat::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSFormat does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSFormat does not use op4p()");
    break;
}
case VNType::atSFormatF: {
    const AstSFormatF* const currp = static_cast<const AstSFormatF*>(this);
    // Checking op1p
    if (const AstNodeExpr* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstSFormatF::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSFormatF does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSFormatF does not use op4p()");
    break;
}
case VNType::atSScanF: {
    const AstSScanF* const currp = static_cast<const AstSScanF*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(currp->fromp(), currp, "AstSScanF must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSScanF::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSScanF does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSScanF does not use op4p()");
    break;
}
case VNType::atSampleQueueDType: {
    const AstSampleQueueDType* const currp = static_cast<const AstSampleQueueDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstSampleQueueDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSampleQueueDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSampleQueueDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSampleQueueDType does not use op4p()");
    break;
}
case VNType::atSampled: {
    const AstSampled* const currp = static_cast<const AstSampled*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstSampled must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstSampled::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSampled does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSampled does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSampled does not use op4p()");
    break;
}
case VNType::atScCtor: {
    const AstScCtor* const currp = static_cast<const AstScCtor*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstScCtor does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstScCtor does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScCtor does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScCtor does not use op4p()");
    break;
}
case VNType::atScDtor: {
    const AstScDtor* const currp = static_cast<const AstScDtor*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstScDtor does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstScDtor does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScDtor does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScDtor does not use op4p()");
    break;
}
case VNType::atScHdr: {
    const AstScHdr* const currp = static_cast<const AstScHdr*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstScHdr does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstScHdr does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScHdr does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScHdr does not use op4p()");
    break;
}
case VNType::atScImp: {
    const AstScImp* const currp = static_cast<const AstScImp*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstScImp does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstScImp does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScImp does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScImp does not use op4p()");
    break;
}
case VNType::atScImpHdr: {
    const AstScImpHdr* const currp = static_cast<const AstScImpHdr*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstScImpHdr does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstScImpHdr does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScImpHdr does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScImpHdr does not use op4p()");
    break;
}
case VNType::atScInt: {
    const AstScInt* const currp = static_cast<const AstScInt*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstScInt does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstScInt does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScInt does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScInt does not use op4p()");
    break;
}
case VNType::atScope: {
    const AstScope* const currp = static_cast<const AstScope*>(this);
    // Checking op1p
    if (const AstVarScope* const headp = currp->varsp()) {
        const AstNode* backp = currp;
        const AstVarScope* tailp = headp;
        const AstVarScope* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), VarScope);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstNode* const headp = currp->blocksp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScope does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScope does not use op4p()");
    break;
}
case VNType::atScopeName: {
    const AstScopeName* const currp = static_cast<const AstScopeName*>(this);
    // Checking op1p
    if (const AstText* const headp = currp->scopeAttrp()) {
        const AstNode* backp = currp;
        const AstText* tailp = headp;
        const AstText* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Text);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    if (const AstText* const headp = currp->scopeEntrp()) {
        const AstNode* backp = currp;
        const AstText* tailp = headp;
        const AstText* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), Text);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstScopeName does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstScopeName does not use op4p()");
    break;
}
case VNType::atSel: {
    const AstSel* const currp = static_cast<const AstSel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstSel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->lsbp(), currp, "AstSel must have non nullptr lsbp()");
    UASSERT_OBJ(!currp->lsbp()->nextp(), currp, "AstSel::lsbp() cannot have a non nullptr nextp()");
    currp->lsbp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->widthp(), currp, "AstSel must have non nullptr widthp()");
    UASSERT_OBJ(!currp->widthp()->nextp(), currp, "AstSel::widthp() cannot have a non nullptr nextp()");
    currp->widthp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSel does not use op4p()");
    break;
}
case VNType::atSelBit: {
    const AstSelBit* const currp = static_cast<const AstSelBit*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstSelBit must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSelBit::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->bitp(), currp, "AstSelBit must have non nullptr bitp()");
    UASSERT_OBJ(!currp->bitp()->nextp(), currp, "AstSelBit::bitp() cannot have a non nullptr nextp()");
    currp->bitp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNodeExpr* const opp = currp->thsp()) {
        UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstSelBit::thsp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstAttrOf* const opp = currp->attrp()) {
        UASSERT_OBJ(!currp->attrp()->nextp(), currp, "AstSelBit::attrp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atSelExtract: {
    const AstSelExtract* const currp = static_cast<const AstSelExtract*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstSelExtract must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSelExtract::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->leftp(), currp, "AstSelExtract must have non nullptr leftp()");
    UASSERT_OBJ(!currp->leftp()->nextp(), currp, "AstSelExtract::leftp() cannot have a non nullptr nextp()");
    currp->leftp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNodeExpr* const opp = currp->rightp()) {
        UASSERT_OBJ(!currp->rightp()->nextp(), currp, "AstSelExtract::rightp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstAttrOf* const opp = currp->attrp()) {
        UASSERT_OBJ(!currp->attrp()->nextp(), currp, "AstSelExtract::attrp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atSelLoopVars: {
    const AstSelLoopVars* const currp = static_cast<const AstSelLoopVars*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstSelLoopVars must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSelLoopVars::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->elementsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSelLoopVars does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSelLoopVars does not use op4p()");
    break;
}
case VNType::atSelMinus: {
    const AstSelMinus* const currp = static_cast<const AstSelMinus*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstSelMinus must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSelMinus::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->bitp(), currp, "AstSelMinus must have non nullptr bitp()");
    UASSERT_OBJ(!currp->bitp()->nextp(), currp, "AstSelMinus::bitp() cannot have a non nullptr nextp()");
    currp->bitp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNodeExpr* const opp = currp->widtph()) {
        UASSERT_OBJ(!currp->widtph()->nextp(), currp, "AstSelMinus::widtph() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstAttrOf* const opp = currp->attrp()) {
        UASSERT_OBJ(!currp->attrp()->nextp(), currp, "AstSelMinus::attrp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atSelPlus: {
    const AstSelPlus* const currp = static_cast<const AstSelPlus*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstSelPlus must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSelPlus::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->bitp(), currp, "AstSelPlus must have non nullptr bitp()");
    UASSERT_OBJ(!currp->bitp()->nextp(), currp, "AstSelPlus::bitp() cannot have a non nullptr nextp()");
    currp->bitp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNodeExpr* const opp = currp->widtph()) {
        UASSERT_OBJ(!currp->widtph()->nextp(), currp, "AstSelPlus::widtph() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstAttrOf* const opp = currp->attrp()) {
        UASSERT_OBJ(!currp->attrp()->nextp(), currp, "AstSelPlus::attrp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atSenItem: {
    const AstSenItem* const currp = static_cast<const AstSenItem*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->sensp()) {
        UASSERT_OBJ(!currp->sensp()->nextp(), currp, "AstSenItem::sensp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSenItem does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSenItem does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSenItem does not use op4p()");
    break;
}
case VNType::atSenTree: {
    const AstSenTree* const currp = static_cast<const AstSenTree*>(this);
    // Checking op1p
    if (const AstSenItem* const headp = currp->sensesp()) {
        const AstNode* backp = currp;
        const AstSenItem* tailp = headp;
        const AstSenItem* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), SenItem);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSenTree does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSenTree does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSenTree does not use op4p()");
    break;
}
case VNType::atSetAssoc: {
    const AstSetAssoc* const currp = static_cast<const AstSetAssoc*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSetAssoc must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSetAssoc::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    if (AstNode* const opp = currp->keyp()) {
        UASSERT_OBJ(!currp->keyp()->nextp(), currp, "AstSetAssoc::keyp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(currp->valuep(), currp, "AstSetAssoc must have non nullptr valuep()");
    UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstSetAssoc::valuep() cannot have a non nullptr nextp()");
    currp->valuep()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSetAssoc does not use op4p()");
    break;
}
case VNType::atSetWildcard: {
    const AstSetWildcard* const currp = static_cast<const AstSetWildcard*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSetWildcard must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSetWildcard::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    if (AstNode* const opp = currp->keyp()) {
        UASSERT_OBJ(!currp->keyp()->nextp(), currp, "AstSetWildcard::keyp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(currp->valuep(), currp, "AstSetWildcard must have non nullptr valuep()");
    UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstSetWildcard::valuep() cannot have a non nullptr nextp()");
    currp->valuep()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSetWildcard does not use op4p()");
    break;
}
case VNType::atShiftL: {
    const AstShiftL* const currp = static_cast<const AstShiftL*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstShiftL must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstShiftL::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstShiftL must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstShiftL::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstShiftL does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstShiftL does not use op4p()");
    break;
}
case VNType::atShiftR: {
    const AstShiftR* const currp = static_cast<const AstShiftR*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstShiftR must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstShiftR::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstShiftR must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstShiftR::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstShiftR does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstShiftR does not use op4p()");
    break;
}
case VNType::atShiftRS: {
    const AstShiftRS* const currp = static_cast<const AstShiftRS*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstShiftRS must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstShiftRS::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstShiftRS must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstShiftRS::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstShiftRS does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstShiftRS does not use op4p()");
    break;
}
case VNType::atSigned: {
    const AstSigned* const currp = static_cast<const AstSigned*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSigned must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSigned::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSigned does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSigned does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSigned does not use op4p()");
    break;
}
case VNType::atSinD: {
    const AstSinD* const currp = static_cast<const AstSinD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSinD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSinD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSinD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSinD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSinD does not use op4p()");
    break;
}
case VNType::atSinhD: {
    const AstSinhD* const currp = static_cast<const AstSinhD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSinhD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSinhD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSinhD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSinhD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSinhD does not use op4p()");
    break;
}
case VNType::atSliceSel: {
    const AstSliceSel* const currp = static_cast<const AstSliceSel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstSliceSel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstSliceSel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstSliceSel must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstSliceSel::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstSliceSel must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstSliceSel::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSliceSel does not use op4p()");
    break;
}
case VNType::atSplitPlaceholder: {
    const AstSplitPlaceholder* const currp = static_cast<const AstSplitPlaceholder*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstSplitPlaceholder does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSplitPlaceholder does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSplitPlaceholder does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSplitPlaceholder does not use op4p()");
    break;
}
case VNType::atSqrtD: {
    const AstSqrtD* const currp = static_cast<const AstSqrtD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSqrtD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSqrtD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSqrtD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSqrtD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSqrtD does not use op4p()");
    break;
}
case VNType::atStable: {
    const AstStable* const currp = static_cast<const AstStable*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstStable must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstStable::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    if (AstSenTree* const opp = currp->sentreep()) {
        UASSERT_OBJ(!currp->sentreep()->nextp(), currp, "AstStable::sentreep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStable does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStable does not use op4p()");
    break;
}
case VNType::atStackTraceF: {
    const AstStackTraceF* const currp = static_cast<const AstStackTraceF*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstStackTraceF does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStackTraceF does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStackTraceF does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStackTraceF does not use op4p()");
    break;
}
case VNType::atStackTraceT: {
    const AstStackTraceT* const currp = static_cast<const AstStackTraceT*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstStackTraceT does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStackTraceT does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStackTraceT does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStackTraceT does not use op4p()");
    break;
}
case VNType::atStmtExpr: {
    const AstStmtExpr* const currp = static_cast<const AstStmtExpr*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->exprp(), currp, "AstStmtExpr must have non nullptr exprp()");
    UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstStmtExpr::exprp() cannot have a non nullptr nextp()");
    currp->exprp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStmtExpr does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStmtExpr does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStmtExpr does not use op4p()");
    break;
}
case VNType::atStop: {
    const AstStop* const currp = static_cast<const AstStop*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstStop does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStop does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStop does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStop does not use op4p()");
    break;
}
case VNType::atStreamDType: {
    const AstStreamDType* const currp = static_cast<const AstStreamDType*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstStreamDType does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStreamDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStreamDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStreamDType does not use op4p()");
    break;
}
case VNType::atStreamL: {
    const AstStreamL* const currp = static_cast<const AstStreamL*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstStreamL must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstStreamL::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstStreamL must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstStreamL::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStreamL does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStreamL does not use op4p()");
    break;
}
case VNType::atStreamR: {
    const AstStreamR* const currp = static_cast<const AstStreamR*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstStreamR must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstStreamR::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstStreamR must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstStreamR::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStreamR does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStreamR does not use op4p()");
    break;
}
case VNType::atStrengthSpec: {
    const AstStrengthSpec* const currp = static_cast<const AstStrengthSpec*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstStrengthSpec does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStrengthSpec does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStrengthSpec does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStrengthSpec does not use op4p()");
    break;
}
case VNType::atStructDType: {
    const AstStructDType* const currp = static_cast<const AstStructDType*>(this);
    // Checking op1p
    if (const AstMemberDType* const headp = currp->membersp()) {
        const AstNode* backp = currp;
        const AstMemberDType* tailp = headp;
        const AstMemberDType* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), MemberDType);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStructDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStructDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStructDType does not use op4p()");
    break;
}
case VNType::atStructSel: {
    const AstStructSel* const currp = static_cast<const AstStructSel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstStructSel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstStructSel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstStructSel does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstStructSel does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstStructSel does not use op4p()");
    break;
}
case VNType::atSub: {
    const AstSub* const currp = static_cast<const AstSub*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSub must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSub::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstSub must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstSub::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSub does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSub does not use op4p()");
    break;
}
case VNType::atSubD: {
    const AstSubD* const currp = static_cast<const AstSubD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSubD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSubD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstSubD must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstSubD::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSubD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSubD does not use op4p()");
    break;
}
case VNType::atSubstrN: {
    const AstSubstrN* const currp = static_cast<const AstSubstrN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSubstrN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSubstrN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstSubstrN must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstSubstrN::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->thsp(), currp, "AstSubstrN must have non nullptr thsp()");
    UASSERT_OBJ(!currp->thsp()->nextp(), currp, "AstSubstrN::thsp() cannot have a non nullptr nextp()");
    currp->thsp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSubstrN does not use op4p()");
    break;
}
case VNType::atSysFuncAsTask: {
    const AstSysFuncAsTask* const currp = static_cast<const AstSysFuncAsTask*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSysFuncAsTask must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSysFuncAsTask::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSysFuncAsTask does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSysFuncAsTask does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSysFuncAsTask does not use op4p()");
    break;
}
case VNType::atSysIgnore: {
    const AstSysIgnore* const currp = static_cast<const AstSysIgnore*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSysIgnore does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSysIgnore does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSysIgnore does not use op4p()");
    break;
}
case VNType::atSystemF: {
    const AstSystemF* const currp = static_cast<const AstSystemF*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSystemF must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSystemF::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSystemF does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSystemF does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSystemF does not use op4p()");
    break;
}
case VNType::atSystemT: {
    const AstSystemT* const currp = static_cast<const AstSystemT*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstSystemT must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstSystemT::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstSystemT does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstSystemT does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstSystemT does not use op4p()");
    break;
}
case VNType::atTanD: {
    const AstTanD* const currp = static_cast<const AstTanD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstTanD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstTanD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTanD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTanD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTanD does not use op4p()");
    break;
}
case VNType::atTanhD: {
    const AstTanhD* const currp = static_cast<const AstTanhD*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstTanhD must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstTanhD::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTanhD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTanhD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTanhD does not use op4p()");
    break;
}
case VNType::atTask: {
    const AstTask* const currp = static_cast<const AstTask*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->fvarp()) {
        UASSERT_OBJ(!currp->fvarp()->nextp(), currp, "AstTask::fvarp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstNode* const opp = currp->classOrPackagep()) {
        UASSERT_OBJ(!currp->classOrPackagep()->nextp(), currp, "AstTask::classOrPackagep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstTask::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atTaskRef: {
    const AstTaskRef* const currp = static_cast<const AstTaskRef*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->namep()) {
        UASSERT_OBJ(!currp->namep()->nextp(), currp, "AstTaskRef::namep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTaskRef does not use op2p()");
    // Checking op3p
    if (const AstNodeExpr* const headp = currp->pinsp()) {
        const AstNode* backp = currp;
        const AstNodeExpr* tailp = headp;
        const AstNodeExpr* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeExpr);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (AstScopeName* const opp = currp->scopeNamep()) {
        UASSERT_OBJ(!currp->scopeNamep()->nextp(), currp, "AstTaskRef::scopeNamep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atTestPlusArgs: {
    const AstTestPlusArgs* const currp = static_cast<const AstTestPlusArgs*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->searchp()) {
        UASSERT_OBJ(!currp->searchp()->nextp(), currp, "AstTestPlusArgs::searchp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTestPlusArgs does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTestPlusArgs does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTestPlusArgs does not use op4p()");
    break;
}
case VNType::atText: {
    const AstText* const currp = static_cast<const AstText*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstText does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstText does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstText does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstText does not use op4p()");
    break;
}
case VNType::atTextBlock: {
    const AstTextBlock* const currp = static_cast<const AstTextBlock*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->nodesp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTextBlock does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTextBlock does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTextBlock does not use op4p()");
    break;
}
case VNType::atThisRef: {
    const AstThisRef* const currp = static_cast<const AstThisRef*>(this);
    // Checking op1p
    if (AstClassRefDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstThisRef::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstThisRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstThisRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstThisRef does not use op4p()");
    break;
}
case VNType::atTime: {
    const AstTime* const currp = static_cast<const AstTime*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstTime does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTime does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTime does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTime does not use op4p()");
    break;
}
case VNType::atTimeD: {
    const AstTimeD* const currp = static_cast<const AstTimeD*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstTimeD does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTimeD does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTimeD does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTimeD does not use op4p()");
    break;
}
case VNType::atTimeFormat: {
    const AstTimeFormat* const currp = static_cast<const AstTimeFormat*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->unitsp(), currp, "AstTimeFormat must have non nullptr unitsp()");
    UASSERT_OBJ(!currp->unitsp()->nextp(), currp, "AstTimeFormat::unitsp() cannot have a non nullptr nextp()");
    currp->unitsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->precisionp(), currp, "AstTimeFormat must have non nullptr precisionp()");
    UASSERT_OBJ(!currp->precisionp()->nextp(), currp, "AstTimeFormat::precisionp() cannot have a non nullptr nextp()");
    currp->precisionp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(currp->suffixp(), currp, "AstTimeFormat must have non nullptr suffixp()");
    UASSERT_OBJ(!currp->suffixp()->nextp(), currp, "AstTimeFormat::suffixp() cannot have a non nullptr nextp()");
    currp->suffixp()->checkTreeIter(currp);
    // Checking op4p
    UASSERT_OBJ(currp->widthp(), currp, "AstTimeFormat must have non nullptr widthp()");
    UASSERT_OBJ(!currp->widthp()->nextp(), currp, "AstTimeFormat::widthp() cannot have a non nullptr nextp()");
    currp->widthp()->checkTreeIter(currp);
    break;
}
case VNType::atTimeImport: {
    const AstTimeImport* const currp = static_cast<const AstTimeImport*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstTimeImport must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstTimeImport::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTimeImport does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTimeImport does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTimeImport does not use op4p()");
    break;
}
case VNType::atTimePrecision: {
    const AstTimePrecision* const currp = static_cast<const AstTimePrecision*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstTimePrecision does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTimePrecision does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTimePrecision does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTimePrecision does not use op4p()");
    break;
}
case VNType::atTimeUnit: {
    const AstTimeUnit* const currp = static_cast<const AstTimeUnit*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstTimeUnit does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTimeUnit does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTimeUnit does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTimeUnit does not use op4p()");
    break;
}
case VNType::atToLowerN: {
    const AstToLowerN* const currp = static_cast<const AstToLowerN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstToLowerN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstToLowerN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstToLowerN does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstToLowerN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstToLowerN does not use op4p()");
    break;
}
case VNType::atToUpperN: {
    const AstToUpperN* const currp = static_cast<const AstToUpperN*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstToUpperN must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstToUpperN::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstToUpperN does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstToUpperN does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstToUpperN does not use op4p()");
    break;
}
case VNType::atTopScope: {
    const AstTopScope* const currp = static_cast<const AstTopScope*>(this);
    // Checking op1p
    if (const AstSenTree* const headp = currp->senTreesp()) {
        const AstNode* backp = currp;
        const AstSenTree* tailp = headp;
        const AstSenTree* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), SenTree);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(currp->scopep(), currp, "AstTopScope must have non nullptr scopep()");
    UASSERT_OBJ(!currp->scopep()->nextp(), currp, "AstTopScope::scopep() cannot have a non nullptr nextp()");
    currp->scopep()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTopScope does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTopScope does not use op4p()");
    break;
}
case VNType::atTraceDecl: {
    const AstTraceDecl* const currp = static_cast<const AstTraceDecl*>(this);
    // Checking op1p
    if (AstNodeExpr* const opp = currp->valuep()) {
        UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstTraceDecl::valuep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTraceDecl does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTraceDecl does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTraceDecl does not use op4p()");
    break;
}
case VNType::atTraceInc: {
    const AstTraceInc* const currp = static_cast<const AstTraceInc*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->precondsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(currp->valuep(), currp, "AstTraceInc must have non nullptr valuep()");
    UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstTraceInc::valuep() cannot have a non nullptr nextp()");
    currp->valuep()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTraceInc does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTraceInc does not use op4p()");
    break;
}
case VNType::atTracePopNamePrefix: {
    const AstTracePopNamePrefix* const currp = static_cast<const AstTracePopNamePrefix*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstTracePopNamePrefix does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTracePopNamePrefix does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTracePopNamePrefix does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTracePopNamePrefix does not use op4p()");
    break;
}
case VNType::atTracePushNamePrefix: {
    const AstTracePushNamePrefix* const currp = static_cast<const AstTracePushNamePrefix*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstTracePushNamePrefix does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTracePushNamePrefix does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTracePushNamePrefix does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTracePushNamePrefix does not use op4p()");
    break;
}
case VNType::atTypeTable: {
    const AstTypeTable* const currp = static_cast<const AstTypeTable*>(this);
    // Checking op1p
    if (const AstNodeDType* const headp = currp->typesp()) {
        const AstNode* backp = currp;
        const AstNodeDType* tailp = headp;
        const AstNodeDType* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), NodeDType);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTypeTable does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTypeTable does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTypeTable does not use op4p()");
    break;
}
case VNType::atTypedef: {
    const AstTypedef* const currp = static_cast<const AstTypedef*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstTypedef::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTypedef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTypedef does not use op3p()");
    // Checking op4p
    if (const AstNode* const headp = currp->attrsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atTypedefFwd: {
    const AstTypedefFwd* const currp = static_cast<const AstTypedefFwd*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstTypedefFwd does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstTypedefFwd does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstTypedefFwd does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstTypedefFwd does not use op4p()");
    break;
}
case VNType::atUCFunc: {
    const AstUCFunc* const currp = static_cast<const AstUCFunc*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUCFunc does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUCFunc does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUCFunc does not use op4p()");
    break;
}
case VNType::atUCStmt: {
    const AstUCStmt* const currp = static_cast<const AstUCStmt*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->exprsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUCStmt does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUCStmt does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUCStmt does not use op4p()");
    break;
}
case VNType::atURandomRange: {
    const AstURandomRange* const currp = static_cast<const AstURandomRange*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstURandomRange must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstURandomRange::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstURandomRange must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstURandomRange::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstURandomRange does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstURandomRange does not use op4p()");
    break;
}
case VNType::atUdpTable: {
    const AstUdpTable* const currp = static_cast<const AstUdpTable*>(this);
    // Checking op1p
    if (const AstUdpTableLine* const headp = currp->linesp()) {
        const AstNode* backp = currp;
        const AstUdpTableLine* tailp = headp;
        const AstUdpTableLine* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), UdpTableLine);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUdpTable does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUdpTable does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUdpTable does not use op4p()");
    break;
}
case VNType::atUdpTableLine: {
    const AstUdpTableLine* const currp = static_cast<const AstUdpTableLine*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstUdpTableLine does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUdpTableLine does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUdpTableLine does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUdpTableLine does not use op4p()");
    break;
}
case VNType::atUnbounded: {
    const AstUnbounded* const currp = static_cast<const AstUnbounded*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstUnbounded does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUnbounded does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUnbounded does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUnbounded does not use op4p()");
    break;
}
case VNType::atUnionDType: {
    const AstUnionDType* const currp = static_cast<const AstUnionDType*>(this);
    // Checking op1p
    if (const AstMemberDType* const headp = currp->membersp()) {
        const AstNode* backp = currp;
        const AstMemberDType* tailp = headp;
        const AstMemberDType* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = VN_AS(opp->nextp(), MemberDType);
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUnionDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUnionDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUnionDType does not use op4p()");
    break;
}
case VNType::atUnlinkedRef: {
    const AstUnlinkedRef* const currp = static_cast<const AstUnlinkedRef*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->refp(), currp, "AstUnlinkedRef must have non nullptr refp()");
    UASSERT_OBJ(!currp->refp()->nextp(), currp, "AstUnlinkedRef::refp() cannot have a non nullptr nextp()");
    currp->refp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->cellrefp(), currp, "AstUnlinkedRef must have non nullptr cellrefp()");
    UASSERT_OBJ(!currp->cellrefp()->nextp(), currp, "AstUnlinkedRef::cellrefp() cannot have a non nullptr nextp()");
    currp->cellrefp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUnlinkedRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUnlinkedRef does not use op4p()");
    break;
}
case VNType::atUnpackArrayDType: {
    const AstUnpackArrayDType* const currp = static_cast<const AstUnpackArrayDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstUnpackArrayDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstRange* const opp = currp->rangep()) {
        UASSERT_OBJ(!currp->rangep()->nextp(), currp, "AstUnpackArrayDType::rangep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUnpackArrayDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUnpackArrayDType does not use op4p()");
    break;
}
case VNType::atUnsigned: {
    const AstUnsigned* const currp = static_cast<const AstUnsigned*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstUnsigned must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstUnsigned::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUnsigned does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUnsigned does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUnsigned does not use op4p()");
    break;
}
case VNType::atUnsizedArrayDType: {
    const AstUnsizedArrayDType* const currp = static_cast<const AstUnsizedArrayDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstUnsizedArrayDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUnsizedArrayDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUnsizedArrayDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUnsizedArrayDType does not use op4p()");
    break;
}
case VNType::atUnsizedRange: {
    const AstUnsizedRange* const currp = static_cast<const AstUnsizedRange*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstUnsizedRange does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstUnsizedRange does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstUnsizedRange does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstUnsizedRange does not use op4p()");
    break;
}
case VNType::atVFile: {
    const AstVFile* const currp = static_cast<const AstVFile*>(this);
    // Checking op1p
    if (AstTextBlock* const opp = currp->tblockp()) {
        UASSERT_OBJ(!currp->tblockp()->nextp(), currp, "AstVFile::tblockp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstVFile does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstVFile does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstVFile does not use op4p()");
    break;
}
case VNType::atValuePlusArgs: {
    const AstValuePlusArgs* const currp = static_cast<const AstValuePlusArgs*>(this);
    // Checking op1p
    if (AstNode* const opp = currp->searchp()) {
        UASSERT_OBJ(!currp->searchp()->nextp(), currp, "AstValuePlusArgs::searchp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(currp->outp(), currp, "AstValuePlusArgs must have non nullptr outp()");
    UASSERT_OBJ(!currp->outp()->nextp(), currp, "AstValuePlusArgs::outp() cannot have a non nullptr nextp()");
    currp->outp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstValuePlusArgs does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstValuePlusArgs does not use op4p()");
    break;
}
case VNType::atVar: {
    const AstVar* const currp = static_cast<const AstVar*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstVar::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    if (AstDelay* const opp = currp->delayp()) {
        UASSERT_OBJ(!currp->delayp()->nextp(), currp, "AstVar::delayp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    if (AstNode* const opp = currp->valuep()) {
        UASSERT_OBJ(!currp->valuep()->nextp(), currp, "AstVar::valuep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (const AstNode* const headp = currp->attrsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atVarRef: {
    const AstVarRef* const currp = static_cast<const AstVarRef*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstVarRef does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstVarRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstVarRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstVarRef does not use op4p()");
    break;
}
case VNType::atVarScope: {
    const AstVarScope* const currp = static_cast<const AstVarScope*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstVarScope does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstVarScope does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstVarScope does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstVarScope does not use op4p()");
    break;
}
case VNType::atVarXRef: {
    const AstVarXRef* const currp = static_cast<const AstVarXRef*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstVarXRef does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstVarXRef does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstVarXRef does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstVarXRef does not use op4p()");
    break;
}
case VNType::atVoidDType: {
    const AstVoidDType* const currp = static_cast<const AstVoidDType*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstVoidDType does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstVoidDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstVoidDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstVoidDType does not use op4p()");
    break;
}
case VNType::atWait: {
    const AstWait* const currp = static_cast<const AstWait*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->condp(), currp, "AstWait must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstWait::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op2p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstWait does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWait does not use op4p()");
    break;
}
case VNType::atWaitFork: {
    const AstWaitFork* const currp = static_cast<const AstWaitFork*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstWaitFork does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstWaitFork does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstWaitFork does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWaitFork does not use op4p()");
    break;
}
case VNType::atWhile: {
    const AstWhile* const currp = static_cast<const AstWhile*>(this);
    // Checking op1p
    if (const AstNode* const headp = currp->precondsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op2p
    UASSERT_OBJ(currp->condp(), currp, "AstWhile must have non nullptr condp()");
    UASSERT_OBJ(!currp->condp()->nextp(), currp, "AstWhile::condp() cannot have a non nullptr nextp()");
    currp->condp()->checkTreeIter(currp);
    // Checking op3p
    if (const AstNode* const headp = currp->stmtsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    if (const AstNode* const headp = currp->incsp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    break;
}
case VNType::atWildcardArrayDType: {
    const AstWildcardArrayDType* const currp = static_cast<const AstWildcardArrayDType*>(this);
    // Checking op1p
    if (AstNodeDType* const opp = currp->childDTypep()) {
        UASSERT_OBJ(!currp->childDTypep()->nextp(), currp, "AstWildcardArrayDType::childDTypep() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstWildcardArrayDType does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstWildcardArrayDType does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWildcardArrayDType does not use op4p()");
    break;
}
case VNType::atWildcardRange: {
    const AstWildcardRange* const currp = static_cast<const AstWildcardRange*>(this);
    // Checking op1p
    UASSERT_OBJ(!currp->op1p(), currp, "AstWildcardRange does not use op1p()");
    // Checking op2p
    UASSERT_OBJ(!currp->op2p(), currp, "AstWildcardRange does not use op2p()");
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstWildcardRange does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWildcardRange does not use op4p()");
    break;
}
case VNType::atWildcardSel: {
    const AstWildcardSel* const currp = static_cast<const AstWildcardSel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstWildcardSel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstWildcardSel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->bitp(), currp, "AstWildcardSel must have non nullptr bitp()");
    UASSERT_OBJ(!currp->bitp()->nextp(), currp, "AstWildcardSel::bitp() cannot have a non nullptr nextp()");
    currp->bitp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstWildcardSel does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWildcardSel does not use op4p()");
    break;
}
case VNType::atWith: {
    const AstWith* const currp = static_cast<const AstWith*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->indexArgRefp(), currp, "AstWith must have non nullptr indexArgRefp()");
    UASSERT_OBJ(!currp->indexArgRefp()->nextp(), currp, "AstWith::indexArgRefp() cannot have a non nullptr nextp()");
    currp->indexArgRefp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->valueArgRefp(), currp, "AstWith must have non nullptr valueArgRefp()");
    UASSERT_OBJ(!currp->valueArgRefp()->nextp(), currp, "AstWith::valueArgRefp() cannot have a non nullptr nextp()");
    currp->valueArgRefp()->checkTreeIter(currp);
    // Checking op3p
    if (const AstNode* const headp = currp->exprp()) {
        const AstNode* backp = currp;
        const AstNode* tailp = headp;
        const AstNode* opp = headp;
        do {
            opp->checkTreeIter(backp);
            UASSERT_OBJ(opp == headp || !opp->nextp() || !opp->m_headtailp, opp, "Headtailp should be null in middle of lists");
            backp = tailp = opp;
            opp = opp->nextp();
        } while (opp);
        // cppcheck-suppress knownConditionTrueFalse
        if (false && headp && tailp) {}  // Prevent unused
        UASSERT_OBJ(headp->m_headtailp == tailp, headp, "Tail in headtailp is inconsistent");
        UASSERT_OBJ(tailp->m_headtailp == headp, tailp, "Head in headtailp is inconsistent");
    }
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWith does not use op4p()");
    break;
}
case VNType::atWithParse: {
    const AstWithParse* const currp = static_cast<const AstWithParse*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->funcrefp(), currp, "AstWithParse must have non nullptr funcrefp()");
    UASSERT_OBJ(!currp->funcrefp()->nextp(), currp, "AstWithParse::funcrefp() cannot have a non nullptr nextp()");
    currp->funcrefp()->checkTreeIter(currp);
    // Checking op2p
    if (AstNodeExpr* const opp = currp->exprp()) {
        UASSERT_OBJ(!currp->exprp()->nextp(), currp, "AstWithParse::exprp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstWithParse does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWithParse does not use op4p()");
    break;
}
case VNType::atWordSel: {
    const AstWordSel* const currp = static_cast<const AstWordSel*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->fromp(), currp, "AstWordSel must have non nullptr fromp()");
    UASSERT_OBJ(!currp->fromp()->nextp(), currp, "AstWordSel::fromp() cannot have a non nullptr nextp()");
    currp->fromp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->bitp(), currp, "AstWordSel must have non nullptr bitp()");
    UASSERT_OBJ(!currp->bitp()->nextp(), currp, "AstWordSel::bitp() cannot have a non nullptr nextp()");
    currp->bitp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstWordSel does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstWordSel does not use op4p()");
    break;
}
case VNType::atWriteMem: {
    const AstWriteMem* const currp = static_cast<const AstWriteMem*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->filenamep(), currp, "AstWriteMem must have non nullptr filenamep()");
    UASSERT_OBJ(!currp->filenamep()->nextp(), currp, "AstWriteMem::filenamep() cannot have a non nullptr nextp()");
    currp->filenamep()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->memp(), currp, "AstWriteMem must have non nullptr memp()");
    UASSERT_OBJ(!currp->memp()->nextp(), currp, "AstWriteMem::memp() cannot have a non nullptr nextp()");
    currp->memp()->checkTreeIter(currp);
    // Checking op3p
    if (AstNodeExpr* const opp = currp->lsbp()) {
        UASSERT_OBJ(!currp->lsbp()->nextp(), currp, "AstWriteMem::lsbp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    // Checking op4p
    if (AstNodeExpr* const opp = currp->msbp()) {
        UASSERT_OBJ(!currp->msbp()->nextp(), currp, "AstWriteMem::msbp() cannot have a non nullptr nextp()");
        opp->checkTreeIter(currp);
    }
    break;
}
case VNType::atXor: {
    const AstXor* const currp = static_cast<const AstXor*>(this);
    // Checking op1p
    UASSERT_OBJ(currp->lhsp(), currp, "AstXor must have non nullptr lhsp()");
    UASSERT_OBJ(!currp->lhsp()->nextp(), currp, "AstXor::lhsp() cannot have a non nullptr nextp()");
    currp->lhsp()->checkTreeIter(currp);
    // Checking op2p
    UASSERT_OBJ(currp->rhsp(), currp, "AstXor must have non nullptr rhsp()");
    UASSERT_OBJ(!currp->rhsp()->nextp(), currp, "AstXor::rhsp() cannot have a non nullptr nextp()");
    currp->rhsp()->checkTreeIter(currp);
    // Checking op3p
    UASSERT_OBJ(!currp->op3p(), currp, "AstXor does not use op3p()");
    // Checking op4p
    UASSERT_OBJ(!currp->op4p(), currp, "AstXor does not use op4p()");
    break;
}
